package com.livebrush.data
{
   import fl.data.DataProvider;
   
   public dynamic class Settings
   {
      public function Settings()
      {
         super();
      }
      
      public static function objToIndex(o:Object, a:Array, p:String = null) : int
      {
         var index:int = 0;
         for(var i:int = 0; i < a.length; i++)
         {
            if(p == null)
            {
               if(a[i] == o)
               {
                  index = i;
               }
            }
            else if(a[i][p] == o)
            {
               index = i;
            }
         }
         return index;
      }
      
      public static function idToIndex(s:String, a:Array, p:String = null) : int
      {
         var index:int = 0;
         for(var i:int = 0; i < a.length; i++)
         {
            if(p == null)
            {
               if(a[i].toString() == s)
               {
                  index = i;
               }
            }
            else if(a[i][p].toString() == s)
            {
               index = i;
            }
         }
         return index;
      }
      
      public static function varStringToXML(propName:String, obj:Object, value:String = null) : XML
      {
         var xml:XML = null;
         if(value == null)
         {
            xml = new XML(<{propName}>{obj[propName]}</{propName}>);
         }
         else
         {
            xml = new XML(<{propName}>{value}</{propName}>);
         }
         return xml;
      }
      
      public static function isBoolString(value:String) : Boolean
      {
         return value == "true" || value == "false";
      }
      
      public static function traceProp(value:Object, padding:Boolean = true) : String
      {
         return padding ? " (" + value + ") " : "(" + value + ")";
      }
      
      public static function outputChars(char:String = "-", n:int = 1) : String
      {
         var str:String = "";
         for(var i:int = 0; i < n; i++)
         {
            str += char;
         }
         return str;
      }
      
      public static function arrayToDataProvider(a:Array, labelProp:String = "label", dataProp:String = "data") : DataProvider
      {
         var dp:DataProvider = new DataProvider();
         for(var i:int = 0; i < a.length; dp.addItem({
            "label":a[i][labelProp],
            "data":a[i][dataProp]
         }),i++)
         {
         }
         return dp;
      }
      
      public static function attrToElement(xml:XML, addLength:Boolean = false) : XML
      {
         var xmlElement:XML = null;
         var attr:XML = null;
         var child:XML = null;
         for each(attr in xml.@*)
         {
            xmlElement = <{attr.name().toString()}>{attr.toString()}</{attr.name().toString()}>;
            xml.appendChild(xmlElement);
         }
         for each(child in xml..*)
         {
            if(child.nodeKind() == "element")
            {
               for each(attr in child.@*)
               {
                  xmlElement = <{attr.name().toString()}>{attr.toString()}</{attr.name().toString()}>;
                  child.appendChild(xmlElement);
               }
            }
         }
         return xml;
      }
      
      public static function copyArrayOfObjects(a:Array) : Array
      {
         var newItem:Object = null;
         var i:int = 0;
         var newArray:Array = [];
         for(i = 0; i < a.length; i++)
         {
            try
            {
               newItem = a[i].copy();
            }
            catch(e:Error)
            {
               newItem = a[i].clone();
            }
            catch(e:Error)
            {
               newItem = Settings.copyObject(a[i]);
            }
            finally
            {
               newArray.push(newItem);
            }
         }
         return newArray;
      }
      
      public static function copyObject(o:Object) : Object
      {
         var prop:String = null;
         var newObj:Object = {};
         var objCount:int = Settings.getLength(o);
         if(objCount > 0)
         {
            for(prop in o)
            {
               newObj[prop] = copyObject(o[prop]);
            }
         }
         else
         {
            newObj = o;
         }
         return newObj;
      }
      
      public static function traceDynamicObject(o:Object, objName:String = "Object Root", depth:int = 0, toConsol:Boolean = true) : void
      {
         var prop:String = null;
         var output:String = outputChars("  ",depth) + objName + traceProp(typeof o);
         var objCount:int = Settings.getLength(o);
         if(objCount == 0)
         {
            output += "= " + o;
            if(toConsol)
            {
               try
               {
               }
               catch(e:Error)
               {
               }
            }
         }
         else if(objCount > 0)
         {
            output += traceProp(objCount,false);
            if(toConsol)
            {
               try
               {
               }
               catch(e:Error)
               {
               }
            }
            depth++;
            for(prop in o)
            {
               traceDynamicObject(o[prop],prop,depth,toConsol);
            }
         }
      }
      
      public static function getLength(o:Object) : int
      {
         var prop:String = null;
         var objCount:int = 0;
         for(prop in o)
         {
            objCount++;
         }
         return objCount;
      }
      
      public static function outputDynamicObject(o:Object, objName:String = "Object Root", depth:int = 0, toConsol:Boolean = false) : void
      {
         traceDynamicObject(o,objName,0,true);
      }
      
      public static function stringToBoolean(value:String) : Boolean
      {
         return value == "true" ? true : false;
      }
      
      public function traceSettings() : void
      {
         traceDynamicObject(this,"Settings Object");
      }
      
      public function copy() : Settings
      {
         var prop:String = null;
         var newSettings:Settings = new Settings();
         for(prop in this)
         {
            newSettings[prop] = copyObject(this[prop]);
         }
         return newSettings;
      }
      
      public function length() : int
      {
         return Settings.getLength(this);
      }
   }
}

