package com.livebrush.geom
{
   import fl.motion.Color;
   
   public class ColorSequence
   {
      public var colorList:Array;
      
      public var steps:int;
      
      private var fraction:Number;
      
      private var index:int;
      
      private var back:Boolean;
      
      private var fStep:Number;
      
      private var loop:Boolean;
      
      public function ColorSequence(list:Array, steps:int, loop:Boolean = true, back:Boolean = true)
      {
         super();
         this.loop = loop;
         this.back = back;
         this.startSequence(list,steps);
      }
      
      public function randomColor() : uint
      {
         var rand:int = Math.floor(Math.random() * this.colorList.length);
         return this.colorList[rand];
      }
      
      public function interpolate(index1:int, index2:int, f:Number) : uint
      {
         return Color.interpolateColor(this.colorList[index1],this.colorList[index2],f);
      }
      
      public function startSequence(list:Array, steps:int) : void
      {
         this.colorList = list;
         this.steps = steps;
         this.index = 0;
         this.fraction = 0;
         this.fStep = 1 / steps;
      }
      
      public function reset() : void
      {
         this.startSequence(this.colorList,this.steps);
      }
      
      public function nextColor() : uint
      {
         var color1:uint = uint(this.colorList[this.index]);
         var color2:uint = uint(this.colorList[this.index + 1]);
         var tweenColor:uint = Color.interpolateColor(color1,color2,this.fraction);
         this.fraction += this.fStep;
         if(this.fraction > 1)
         {
            if(this.index == this.colorList.length - 2)
            {
               this.index = 0;
            }
            else
            {
               ++this.index;
            }
            this.fraction = 0;
         }
         return tweenColor;
      }
   }
}

