package com.livebrush.geom
{
   import flash.geom.Point;
   
   public class Osc
   {
      private var iSpeed:Number;
      
      public var speed:Number;
      
      public var value:Point;
      
      public var angle:Number;
      
      private var iRange:Point;
      
      public var center:Point;
      
      public var range:Point;
      
      private var iCenter:Point;
      
      public function Osc(x:Number, y:Number, rangeX:Number, rangeY:Number, speed:Number)
      {
         super();
         this.setOsc(x,y,rangeX,rangeY,speed);
      }
      
      public function setOsc(x:Number, y:Number, rangeX:Number, rangeY:Number, speed:Number) : void
      {
         this.center = this.iCenter = new Point(x,y);
         this.range = this.iRange = new Point(rangeX,rangeY);
         this.speed = this.iSpeed = speed;
         this.angle = 0;
         this.value = this.center.clone();
      }
      
      public function update() : Point
      {
         this.value.x = this.center.x + Math.cos(this.angle) * this.range.x;
         this.value.y = this.center.y + Math.sin(this.angle) * this.range.y;
         this.angle += this.speed;
         return this.value;
      }
      
      public function reset() : void
      {
         this.center = this.iCenter;
         this.range = this.iRange;
         this.speed = this.iSpeed;
         this.angle = 0;
         this.value = this.center.clone();
      }
      
      public function get angleDegrees() : Number
      {
         return this.angle * 180 / Math.PI;
      }
   }
}

