package com.livebrush.graphics.canvas
{
   import com.livebrush.data.Settings;
   import com.livebrush.data.Storable;
   import flash.display.BlendMode;
   import flash.events.Event;
   
   public class BackgroundLayer extends ColorLayer implements Storable
   {
      public static var DEFAULT_XML_STRING:String = "<layer type=\"background\" label=\"Background [LOCKED]\" blendMode=\"layer\" alpha=\"1\" color=\"0\" colorPercent=\"1\"><solid color=\"0\"/></layer>";
      
      public function BackgroundLayer(canvas:Canvas, depth:int = 0)
      {
         super(canvas,depth);
         _type = Layer.BACKGROUND;
         label = "Background [LOCKED]";
         this.depth = depth;
      }
      
      public static function getDefaultXML() : XML
      {
         return new XML(DEFAULT_XML_STRING);
      }
      
      override public function getXML() : XML
      {
         var newLayerXML:XML = new XML(<layer type={Layer.BACKGROUND} label={label} blendMode={this.blendMode} alpha={this.alpha} color={color} colorPercent={this.colorPercent}></layer>);
         newLayerXML.appendChild(<solid color={color}/>);
         return newLayerXML;
      }
      
      override public function get colorPercent() : Number
      {
         return 1;
      }
      
      override public function get blendMode() : String
      {
         return BlendMode.LAYER;
      }
      
      override public function setXML(xml:String) : void
      {
         super.setXML(xml);
         dispatchEvent(new Event(Event.COMPLETE,true,false));
      }
      
      override public function set linkedDepths(a:Array) : void
      {
      }
      
      override protected function applyInitProps() : void
      {
      }
      
      override protected function setInitProps(settings:Settings = null) : void
      {
      }
      
      override public function get alpha() : Number
      {
         return 1;
      }
   }
}

