package com.livebrush.graphics.canvas
{
   import com.formatlos.as3.lib.display.BitmapDataUnlimited;
   import com.formatlos.as3.lib.display.events.BitmapDataUnlimitedEvent;
   import com.livebrush.ui.UI;
   import flash.display.Bitmap;
   import flash.display.BitmapData;
   import flash.display.BlendMode;
   import flash.display.MovieClip;
   import flash.display.PixelSnapping;
   import flash.display.Shape;
   import flash.display.Sprite;
   import flash.display.Stage;
   import flash.display.StageQuality;
   import flash.events.Event;
   import flash.events.MouseEvent;
   import flash.geom.Point;
   import flash.geom.Rectangle;
   
   public class Canvas extends Sprite
   {
      public static var STAGE:Stage;
      
      public static var CONTROLS:Sprite;
      
      public static var DEBUG:Sprite;
      
      public static var GLOBAL_CANVAS:Canvas;
      
      public static var sizeRes:Array = [[{
         "x":640,
         "y":480,
         "label":""
      },{
         "x":1067,
         "y":800
      },{
         "x":2667,
         "y":2000
      },{
         "x":5334,
         "y":4000
      }],[{
         "x":800,
         "y":600,
         "label":""
      },{
         "x":1333,
         "y":1000
      },{
         "x":3333,
         "y":2500
      },{
         "x":6666,
         "y":5000
      }],[{
         "x":1024,
         "y":768,
         "label":"Standard"
      },{
         "x":1707,
         "y":1280
      },{
         "x":4267,
         "y":3200
      },{
         "x":8534,
         "y":6400
      }],[{
         "x":1280,
         "y":720,
         "label":"Widescreen"
      },{
         "x":2133,
         "y":1200
      },{
         "x":5333,
         "y":3000
      },{
         "x":10666,
         "y":6000
      }],[{
         "x":1280,
         "y":1024,
         "label":""
      },{
         "x":2133,
         "y":1707
      },{
         "x":5333,
         "y":4267
      },{
         "x":10666,
         "y":9000
      }],[{
         "x":1920,
         "y":1080,
         "label":"HD Widescreen"
      },{
         "x":3200,
         "y":1800
      },{
         "x":8000,
         "y":4500
      },{
         "x":16000,
         "y":9000
      }]];
      
      public static var sizeDPI:Array = [{
         "label":"Normal Quality (72dpi)",
         "data":0
      },{
         "label":"High Quality (150dpi)",
         "data":1
      },{
         "label":"Print Quality (300dpi)",
         "data":2
      }];
      
      private static var _canvasResIndex:int = 0;
      
      private static var _canvasSizeIndex:int = 4;
      
      public var wireframe:Sprite;
      
      public var locked:Boolean = false;
      
      public var comp:Sprite;
      
      public var lastMousePt:Point;
      
      private var maskShape:Shape;
      
      private var _lastAnglePos:Point;
      
      public var lastMouseEvent:MouseEvent;
      
      public var canvasManager:CanvasManager;
      
      private var _speed:Number = 0;
      
      public var layers:Sprite;
      
      private var debug:Sprite;
      
      private var cursor:Sprite;
      
      private var lastColor:uint = 0;
      
      public var sampleLayerComp:Bitmap;
      
      private var frame:Shape;
      
      private var velPt:Point;
      
      private var lastAngleRads:Number;
      
      public var graphicReps:Sprite;
      
      public var mousePt:Point;
      
      public var selection:Sprite;
      
      public var masterComp:Bitmap;
      
      private var workingComps:Array;
      
      public var offset:Point;
      
      public var layersDepth:int;
      
      public var mouseSpeed:Number = 0;
      
      private var vX:Number;
      
      public var controls:Sprite;
      
      internal var dotMc:MovieClip;
      
      public var stylePreviewLayer:Sprite;
      
      private var _mouseChildren:Boolean = true;
      
      public var belowLayerComp:Bitmap;
      
      private var lastVX:Number;
      
      private var lastVY:Number;
      
      private var cursors:Sprite;
      
      public var aboveLayerComp:Bitmap;
      
      public var controlsComp:Bitmap;
      
      private var _angleRads:Number;
      
      public function Canvas(manager:CanvasManager)
      {
         super();
         this.canvasManager = manager;
         this.init();
      }
      
      public static function get VX() : Number
      {
         return GLOBAL_CANVAS.vx;
      }
      
      public static function get VY() : Number
      {
         return GLOBAL_CANVAS.vy;
      }
      
      public static function get SIZE_INDEX() : int
      {
         return _canvasSizeIndex;
      }
      
      public static function get GRAPHIC_REPS() : Sprite
      {
         return Canvas.GLOBAL_CANVAS.graphicReps;
      }
      
      public static function get X() : Number
      {
         return GLOBAL_CANVAS.comp.mouseX;
      }
      
      public static function get Y() : Number
      {
         return GLOBAL_CANVAS.comp.mouseY;
      }
      
      public static function get WIDTH() : int
      {
         return sizeRes[_canvasSizeIndex][_canvasResIndex].x;
      }
      
      public static function get HEIGHT() : int
      {
         return sizeRes[_canvasSizeIndex][_canvasResIndex].y;
      }
      
      public static function get SELECTION() : Sprite
      {
         return Canvas.GLOBAL_CANVAS.selection;
      }
      
      public static function get WIREFRAME() : Sprite
      {
         return Canvas.GLOBAL_CANVAS.wireframe;
      }
      
      public static function get MOUSE_POINT() : Point
      {
         return new Point(X,Y);
      }
      
      public function moveLayer(from:int, to:int) : void
      {
         this.layers.setChildIndex(this.layers.getChildAt(from),to);
      }
      
      public function getNewLayer() : Sprite
      {
         return this.layers.addChild(new Sprite()) as Sprite;
      }
      
      private function init() : void
      {
         this.offset = new Point(0,0);
         this.velPt = new Point();
         this.workingComps = [];
         this.createCanvas();
         doubleClickEnabled = true;
         addEventListener(Event.ADDED_TO_STAGE,this.addedHandler);
      }
      
      private function addedHandler(e:Event) : void
      {
         if(e.target == this && GLOBAL_CANVAS == null)
         {
            removeEventListener(Event.ADDED_TO_STAGE,this.addedHandler);
            this.mousePt = new Point(mouseX,mouseY);
            this.lastMousePt = new Point();
            stage.quality = StageQuality.BEST;
            STAGE = stage;
            GLOBAL_CANVAS = this;
            CONTROLS = this.controls;
            DEBUG = this.debug;
         }
      }
      
      public function get speed() : Number
      {
         return this._speed;
      }
      
      private function setPreviewPosition() : void
      {
         this.stylePreviewLayer.x = this.offset.x + (WIDTH / 2 - 400);
         this.stylePreviewLayer.y = this.offset.y + (HEIGHT / 2 - 300);
      }
      
      public function hide() : void
      {
         this.comp.visible = false;
      }
      
      public function addCursor(mc:MovieClip) : void
      {
         this.cursors.addChild(mc);
      }
      
      public function get actualSpeed() : Number
      {
         return this.mouseSpeed;
      }
      
      public function pointWithinCanvas(x:Number, y:Number) : Boolean
      {
         return this.canvasRect.contains(x,y);
      }
      
      public function get canvasRect() : Rectangle
      {
         return this.comp.getBounds(stage);
      }
      
      public function newCanvasBitmap(rect:Rectangle = null) : Bitmap
      {
         return new Bitmap(this.newCanvasBitmapData(rect),PixelSnapping.AUTO,true);
      }
      
      public function upScale(res:int = 0) : void
      {
         this.layers.width = sizeRes[_canvasSizeIndex][res].x;
         this.layers.height = sizeRes[_canvasSizeIndex][res].y;
      }
      
      public function get angleRads() : Number
      {
         return this._angleRads;
      }
      
      public function getPixelColor(x:Number, y:Number) : uint
      {
         return this.sampleLayerComp.bitmapData.getPixel(x,y);
      }
      
      private function createCanvas() : void
      {
         this.comp = new Sprite();
         this.debug = new Sprite();
         this.controls = new Sprite();
         this.selection = new Sprite();
         this.wireframe = new Sprite();
         this.graphicReps = new Sprite();
         this.graphicReps.alpha = 0;
         this.wireframe.blendMode = this.selection.blendMode = BlendMode.INVERT;
         addChild(this.comp);
         this.aboveLayerComp = this.newCanvasBitmap();
         this.belowLayerComp = this.newCanvasBitmap();
         this.sampleLayerComp = this.newCanvasBitmap();
         this.masterComp = this.newCanvasBitmap();
         this.comp.addChild(this.belowLayerComp);
         this.layers = new Sprite();
         this.comp.addChild(this.layers);
         this.layersDepth = this.comp.getChildIndex(this.layers);
         this.maskShape = new Shape();
         this.maskShape.graphics.beginFill(16711680);
         this.maskShape.graphics.drawRect(0,0,WIDTH,HEIGHT);
         addChild(this.maskShape);
         this.frame = new Shape();
         this.frame.graphics.lineStyle(1,0,1);
         this.frame.graphics.drawRect(0,0,WIDTH,HEIGHT);
         addChild(this.frame);
         this.comp.mask = this.maskShape;
         this.comp.addChild(this.aboveLayerComp);
         this.comp.addChild(this.masterComp);
         this.comp.addChild(this.graphicReps);
         this.comp.addChild(this.wireframe);
         this.stylePreviewLayer = UI.PREVIEW_HOLDER;
         addChild(this.controls);
         addChild(this.selection);
         addChild(this.debug);
         this.cursors = new Sprite();
         addChild(this.cursors);
      }
      
      public function updateCursor(force:Boolean = false) : void
      {
         var slowVX:Number = NaN;
         var slowVY:Number = NaN;
         var dist:Number = NaN;
         var newPt:Point = new Point(mouseX,mouseY);
         this.mousePt = newPt;
         this.velPt.x = this.mousePt.x - this.lastMousePt.x;
         this.velPt.y = this.mousePt.y - this.lastMousePt.y;
         this.mouseSpeed = Point.distance(newPt,this.lastMousePt);
         var angle:Number = Math.atan2(this.vy,this.vx);
         if(this.mouseSpeed > 4 || force || this._lastAnglePos == null)
         {
            this._angleRads = angle;
            this._lastAnglePos = this.mousePt;
            this.lastAngleRads = angle;
         }
         else
         {
            slowVX = this.mousePt.x - this._lastAnglePos.x;
            slowVY = this.mousePt.y - this._lastAnglePos.y;
            dist = Point.distance(this.mousePt,this._lastAnglePos);
            if(dist > 10)
            {
               this._angleRads = Math.atan2(slowVY,slowVX);
               this._lastAnglePos = this.mousePt;
            }
         }
         this.lastMousePt = this.mousePt.clone();
      }
      
      public function setSize(index:int) : void
      {
         this.offset = new Point();
         _canvasSizeIndex = index;
         this.aboveLayerComp.bitmapData.dispose();
         this.belowLayerComp.bitmapData.dispose();
         this.masterComp.bitmapData.dispose();
         this.aboveLayerComp.bitmapData = this.newCanvasBitmapData();
         this.belowLayerComp.bitmapData = this.newCanvasBitmapData();
         this.masterComp.bitmapData = this.newCanvasBitmapData();
         var depth:int = this.maskShape.parent.getChildIndex(this.maskShape);
         this.maskShape.parent.removeChild(this.maskShape);
         this.maskShape = new Shape();
         this.maskShape.graphics.beginFill(16711680);
         this.maskShape.graphics.drawRect(0,0,WIDTH,HEIGHT);
         addChildAt(this.maskShape,depth);
         this.comp.mask = this.maskShape;
         depth = this.frame.parent.getChildIndex(this.frame);
         this.frame.parent.removeChild(this.frame);
         this.frame = new Shape();
         this.frame.graphics.lineStyle(1,0,1);
         this.frame.graphics.drawRect(0,0,WIDTH,HEIGHT);
         addChildAt(this.frame,depth);
         this.setPreviewPosition();
      }
      
      public function unlockContent(force:Boolean = false) : void
      {
         if(this.locked)
         {
            mouseChildren = true;
            this.locked = false;
            this.offset = new Point(x,y - 30.7);
            this.setPreviewPosition();
         }
      }
      
      public function getLayer(depth:int) : Sprite
      {
         return this.layers.getChildAt(depth) as Sprite;
      }
      
      public function copyBitmapTo(source:Bitmap, dest:Bitmap) : void
      {
         dest.bitmapData.draw(source.bitmapData,null,null,null,null,true);
      }
      
      public function newCanvasBitmapData(rect:Rectangle = null) : BitmapData
      {
         rect = rect == null ? new Rectangle(0,0,Canvas.WIDTH,Canvas.HEIGHT) : rect;
         return new BitmapData(rect.width,rect.height,true,0);
      }
      
      public function getMouseColor(allLayers:Boolean = true) : uint
      {
         return this.getPixelColor(this.comp.mouseX,this.comp.mouseY);
      }
      
      public function generateCanvasBitmap(res:int, onBmpUReady:Function, onBmpUError:Function) : void
      {
         var bmpU:BitmapDataUnlimited = new BitmapDataUnlimited();
         bmpU.addEventListener(BitmapDataUnlimitedEvent.COMPLETE,onBmpUReady);
         bmpU.addEventListener(BitmapDataUnlimitedEvent.ERROR,onBmpUError);
         bmpU.create(sizeRes[_canvasSizeIndex][res].x,sizeRes[_canvasSizeIndex][res].y,true);
      }
      
      public function getColorAt(x:Number, y:Number) : uint
      {
         var c:uint = 0;
         if(this.pointWithinCanvas(x,y))
         {
            c = this.getPixelColor(x,y);
            this.lastColor = c;
         }
         else
         {
            c = this.lastColor;
         }
         return c;
      }
      
      public function get vx() : Number
      {
         return this.velPt.x;
      }
      
      public function get vy() : Number
      {
         return this.velPt.y;
      }
      
      public function downScale() : void
      {
         this.layers.width = WIDTH;
         this.layers.height = HEIGHT;
      }
      
      public function lockContent() : void
      {
         if(!this.locked)
         {
            this._mouseChildren = mouseChildren;
            mouseChildren = false;
            this.locked = true;
         }
      }
      
      public function clearBitmap(bitmap:Bitmap) : void
      {
         bitmap.bitmapData.dispose();
         bitmap.bitmapData = this.newCanvasBitmapData();
         bitmap.smoothing = true;
      }
      
      public function show() : void
      {
         this.comp.visible = true;
      }
   }
}

