package com.livebrush.graphics.canvas
{
   import com.livebrush.data.Storable;
   import flash.display.Bitmap;
   import flash.display.BitmapData;
   import flash.display.PixelSnapping;
   import flash.events.Event;
   
   public class ColorLayer extends Layer implements Storable
   {
      public function ColorLayer(canvas:Canvas, depth:int = 0)
      {
         super(canvas,depth);
         _type = Layer.COLOR;
         this.init();
      }
      
      private function init() : void
      {
         solid = new Bitmap(new BitmapData(Canvas.WIDTH,Canvas.HEIGHT,false,0),PixelSnapping.AUTO,true);
         graphics.addChild(solid);
         setInitProps();
      }
      
      override public function getXML() : XML
      {
         var newLayerXML:XML = new XML(<layer enabled={enabled} type={Layer.COLOR} label={label} matrix={transformMatrixString} blendMode={blendMode} alpha={alpha} scaleX={scaleX} scaleY={scaleY} rotation={rotation} x={x} y={y} color={color} colorPercent={colorPercent}></layer>);
         newLayerXML.appendChild(<solid color={color}/>);
         return newLayerXML;
      }
      
      override protected function applyInitProps() : void
      {
         x = initProps.x;
         y = initProps.y;
         rotation = initProps.rotation;
         scaleX = initProps.scaleX;
         scaleY = initProps.scaleY;
         enabled = initProps.enabled;
         if(initProps.matrix != null)
         {
            transform.matrix = stringToMatrix(initProps.matrix);
         }
         alpha = initProps.alpha;
      }
      
      override public function setXML(xml:String) : void
      {
         super.setXML(xml);
         color = parseInt(layerXML.solid.@color);
         this.setup();
         dispatchEvent(new Event(Event.COMPLETE,true,false));
      }
      
      override public function copy() : Layer
      {
         var newLayer:ColorLayer = null;
         newLayer = new ColorLayer(canvas);
         newLayer.label = label;
         newLayer.alpha = alpha;
         newLayer.blendMode = blendMode;
         newLayer.depth = depth + 1;
         newLayer.color = color;
         setInitProps();
         newLayer.initProps = initProps;
         newLayer.setup();
         return newLayer;
      }
      
      override public function setup() : void
      {
         solid.bitmapData.floodFill(0,0,color);
         this.applyInitProps();
      }
   }
}

