package com.livebrush.graphics.canvas
{
   import com.livebrush.data.FileManager;
   import com.livebrush.data.Storable;
   import flash.display.Bitmap;
   import flash.display.Loader;
   import flash.display.PixelSnapping;
   import flash.events.Event;
   import flash.events.IOErrorEvent;
   
   public class ImageLayer extends Layer implements Storable
   {
      public var src:String;
      
      public var assetCenter:Object;
      
      public function ImageLayer(canvas:Canvas, depth:int = 0)
      {
         super(canvas,depth);
         _type = Layer.IMAGE;
         this.init();
      }
      
      private function initLayer() : void
      {
         if(initProps != null)
         {
            applyInitProps();
         }
         dispatchEvent(new Event(Event.COMPLETE,true,false));
      }
      
      private function loadError(e:IOErrorEvent) : void
      {
         dispatchEvent(new IOErrorEvent(IOErrorEvent.IO_ERROR));
      }
      
      override public function getXML() : XML
      {
         var newLayerXML:XML = new XML(<layer enabled={enabled} type={Layer.IMAGE} label={label} matrix={transformMatrixString} blendMode={blendMode} alpha={alpha} color={color} colorPercent={colorPercent} scaleX={scaleX} scaleY={scaleY} rotation={rotation} x={x} y={y}></layer>);
         newLayerXML.appendChild(<solid src={this.src}/>);
         return newLayerXML;
      }
      
      override public function copy() : Layer
      {
         var newLayer:ImageLayer = null;
         newLayer = new ImageLayer(canvas);
         newLayer.label = label;
         newLayer.alpha = alpha;
         newLayer.blendMode = blendMode;
         newLayer.depth = depth + 1;
         newLayer.src = this.src;
         setInitProps();
         newLayer.initProps = initProps;
         newLayer.setup();
         return newLayer;
      }
      
      private function init() : void
      {
      }
      
      override public function setTransformXML(xml:String) : void
      {
         super.setXML(xml);
         if(initProps != null)
         {
            applyInitProps();
         }
      }
      
      private function duplicateImage(original:Bitmap) : Bitmap
      {
         return new Bitmap(original.bitmapData.clone(),PixelSnapping.AUTO,true);
      }
      
      override public function updateDisplay(cacheGraphics:Boolean = true) : void
      {
         super.updateDisplay();
      }
      
      override public function setXML(xml:String) : void
      {
         super.setXML(xml);
         this.src = layerXML.solid.@src;
         this.setup();
      }
      
      override public function setup() : void
      {
         loader = FileManager.loadLayerImage(this.src,this.contentLoad,this.loadError);
      }
      
      private function contentLoad(e:Event) : void
      {
         var loader:Loader = e.target.loader;
         solid = this.duplicateImage(Bitmap(loader.content));
         graphics.addChild(solid);
         this.assetCenter = {
            "x":solid.width / 2,
            "y":solid.height
         };
         loaded = true;
         this.initLayer();
      }
   }
}

