package com.livebrush.styles
{
   import com.livebrush.data.FileManager;
   
   public dynamic class DecoSet
   {
      public static var index:int = 0;
      
      private var _activeDecos:Array;
      
      private var _decos:Array;
      
      public var selectedDecoIndex:int = 0;
      
      public var name:String;
      
      public var data:String;
      
      public function DecoSet()
      {
         super();
         this._decos = [];
         this._activeDecos = [];
      }
      
      public function get activeDecos() : Array
      {
         return this._decos;
      }
      
      public function set decos(a:Array) : void
      {
         this._decos = a;
      }
      
      public function get length() : int
      {
         return this.decos.length;
      }
      
      public function getXML() : XML
      {
         var decoSetXML:XML = new XML(<decoList></decoList>);
         for(var i:int = 0; i < this.decos.length; i++)
         {
            decoSetXML.appendChild(<deco value={this.decos[i].fileName} enabled={true}></deco>);
         }
         return decoSetXML;
      }
      
      public function removeAllDecos() : void
      {
         this.decos = [];
      }
      
      public function get activeLength() : int
      {
         return this._decos.length;
      }
      
      public function get decos() : Array
      {
         return this._decos;
      }
      
      public function die() : void
      {
         this._decos = [];
         delete global[this];
      }
      
      public function getActiveDecoByIndex(index:int) : DecoAsset
      {
         return this.activeDecos[index];
      }
      
      public function addDeco(assetPath:String, enabled:Boolean = true, forceNew:Boolean = false, index:Number = 0) : void
      {
         var decoAsset:DecoAsset = FileManager.getInstance().getDecoAsset(assetPath,enabled,forceNew);
         this._decos.splice(index + 1,0,decoAsset);
      }
      
      public function removeDeco(index:int) : void
      {
         this.selectedDecoIndex = index;
         this.decos.splice(index,1);
         this.selectedDecoIndex = this.selectedDecoIndex > 0 ? index - 1 : 0;
      }
      
      public function clone() : DecoSet
      {
         var decoSet:DecoSet = new DecoSet();
         for(var i:int = 0; i < this.decos.length; i++)
         {
            decoSet.addDeco(this.decos[i].assetPath,true);
         }
         decoSet.name = this.name;
         return decoSet;
      }
      
      public function moveDeco(index:int, dir:int) : void
      {
         var moveDeco:Object = this.decos[index];
         var inTheWayDeco:Object = this.decos[index + dir];
         this.decos[index + dir] = moveDeco;
         this.decos[index] = inTheWayDeco;
         this.selectedDecoIndex = index + dir;
      }
      
      public function getDecoByIndex(index:int) : DecoAsset
      {
         return this._decos[index];
      }
   }
}

