package com.livebrush.styles
{
   import com.livebrush.data.Exchangeable;
   import com.livebrush.data.FileManager;
   import com.livebrush.data.Settings;
   import com.livebrush.data.Storable;
   import com.livebrush.ui.UI;
   import flash.display.Loader;
   import flash.display.MovieClip;
   import flash.events.Event;
   import flash.events.EventDispatcher;
   import flash.events.IOErrorEvent;
   
   public class LineStyle extends EventDispatcher implements Exchangeable, Storable
   {
      public static const NORMAL:String = "normal";
      
      public static const ELASTIC:String = "elastic";
      
      public static const DYNAMIC:String = "dynamic";
      
      public var friction:Number = 0.47;
      
      public var defaultSettings:Settings;
      
      public var smoothing:Boolean = true;
      
      private var _type:String = "elastic";
      
      public var minDrawSpeed:Number = 0.01;
      
      private var _lockMouse:Boolean = false;
      
      public var styleManager:StyleManager;
      
      public var style:Style;
      
      private var _mouseUpComplete:Boolean = false;
      
      private var _swf:MovieClip;
      
      public var moveFunction:Function;
      
      public var elastic:Number = 0.52;
      
      public var inputSWF:String = "";
      
      public var maxDrawSpeed:Number = 100;
      
      private var elasticMouseUpComplete:Boolean = false;
      
      private var inputLoader:Loader;
      
      public function LineStyle(style:Style)
      {
         super();
         this.style = style;
         this.styleManager = style.styleManager;
         this.defaultSettings = this.settings;
      }
      
      public function die() : void
      {
         this.unloadInputSWF();
         delete global[this];
      }
      
      public function set type(t:String) : void
      {
         this._type = t;
      }
      
      public function getDynamicControl() : Object
      {
         var o:Object = null;
         try
         {
            o = this._swf.getBrushControl();
         }
         catch(e:Error)
         {
            UI.MAIN_UI.alert({
               "message":"<b>Dynamic Input Actionscript Error</b>\n\n<b><a href=\'http://www.Livebrush.com/help/SWF_Support.html\' target=\'_blank\'>Click here</a></b> for Livebrush Help.",
               "id":"inputSWFAlert"
            });
            inputSWF = "";
            type = NORMAL;
         }
         return o;
      }
      
      private function inputSWFLoaded(e:Event) : *
      {
         try
         {
            this._swf = MovieClip(e.target.content);
         }
         catch(e:Error)
         {
            UI.MAIN_UI.alert({
               "message":"<b>Invalid Dynamic Input SWF</b>\nSWF\'s must be exported for Flash Player 9 using Actionscript 3. <b><a href=\'http://www.Livebrush.com/help/SWF_Support.html\' target=\'_blank\'>Click here</a></b> for Livebrush Help.",
               "id":"inputSWFAlert"
            });
            inputSWF = "";
            type = NORMAL;
         }
      }
      
      private function loadErrorHandler(e:IOErrorEvent) : void
      {
         this.type = NORMAL;
         UI.MAIN_UI.alert({
            "message":"<b>Missing Dynamic Input SWF</b>\n\n<b><a href=\'http://www.Livebrush.com/help/SWF_Support.html\' target=\'_blank\'>Click here</a></b> for Livebrush Help.",
            "id":"inputSWFAlert"
         });
         this.inputSWF = "";
         this.type = NORMAL;
      }
      
      public function get settings() : Settings
      {
         var settings:Settings = new Settings();
         settings.lockMouse = this.lockMouse;
         settings.inputSWF = this.inputSWF;
         settings.mouseUpComplete = this.mouseUpComplete;
         settings.type = this.type;
         settings.elastic = this.elastic;
         settings.friction = this.friction;
         settings.minDrawSpeed = this.minDrawSpeed;
         settings.maxDrawSpeed = this.maxDrawSpeed;
         settings.smoothing = this.smoothing;
         return settings;
      }
      
      public function get type() : String
      {
         return this._type != DYNAMIC ? this._type : (this._type == DYNAMIC && this.inputSWF != null && this.inputSWF != "null" && this.inputSWF != "" ? DYNAMIC : NORMAL);
      }
      
      public function set settings(settings:Settings) : void
      {
         this.inputSWF = settings.inputSWF;
         this.mouseUpComplete = settings.mouseUpComplete;
         if(settings.type == ELASTIC && this.type != ELASTIC)
         {
            this.mouseUpComplete = this.elasticMouseUpComplete;
         }
         else if(settings.type != ELASTIC && this.type == ELASTIC)
         {
            this.elasticMouseUpComplete = this.mouseUpComplete;
         }
         if(settings.type != DYNAMIC && this.type == DYNAMIC)
         {
            this.unloadInputSWF();
         }
         else if(settings.type == DYNAMIC && this.type != DYNAMIC)
         {
            this.mouseUpComplete = true;
         }
         this.type = settings.type;
         if(this.type == DYNAMIC)
         {
            this.loadInputSWF();
         }
         this.lockMouse = settings.lockMouse;
         this.elastic = settings.elastic;
         this.friction = settings.friction;
         this.minDrawSpeed = settings.minDrawSpeed;
         this.maxDrawSpeed = settings.maxDrawSpeed;
         this.smoothing = settings.smoothing;
      }
      
      public function setDynamicInput(path:String) : void
      {
         this.inputSWF = path;
         this.type = DYNAMIC;
      }
      
      public function get lockMouse() : Boolean
      {
         return this.type == DYNAMIC ? this._lockMouse : false;
      }
      
      public function setXML(xml:String) : void
      {
         var element:XML = null;
         var drawSpeed:Array = null;
         var lineXML:XML = new XML(xml);
         for each(element in lineXML.*)
         {
            try
            {
               if(element.name() == "drawSpeed")
               {
                  drawSpeed = element.toString().split(",");
                  this.minDrawSpeed = drawSpeed[0];
                  this.maxDrawSpeed = drawSpeed[1];
               }
               else if(element.name() == "smoothing")
               {
                  this.smoothing = element == "true" ? true : false;
               }
               else if(element.name() == "mouseUpComplete")
               {
                  this.mouseUpComplete = element == "true" ? true : false;
               }
               else
               {
                  this[element.name()] = element;
               }
            }
            catch(e:Error)
            {
            }
         }
      }
      
      public function clone(style:Style) : LineStyle
      {
         var lineStyle:LineStyle = new LineStyle(style);
         lineStyle.settings = this.settings;
         return lineStyle;
      }
      
      public function getXML() : XML
      {
         var lineXML:XML = new XML(<line/>);
         lineXML.appendChild(<type>{this.type}</type>);
         lineXML.appendChild(<inputSWF>{this.type == DYNAMIC ? this.inputSWF : ""}</inputSWF>);
         lineXML.appendChild(<elastic>{this.elastic}</elastic>);
         lineXML.appendChild(<friction>{this.friction}</friction>);
         lineXML.appendChild(<drawSpeed>{this.minDrawSpeed + "," + this.maxDrawSpeed}</drawSpeed>);
         lineXML.appendChild(<smoothing>{this.smoothing}</smoothing>);
         lineXML.appendChild(<mouseUpComplete>{this.mouseUpComplete}</mouseUpComplete>);
         return lineXML;
      }
      
      public function loadInputSWF() : void
      {
         if(this.inputLoader != null)
         {
            this.unloadInputSWF();
         }
         this.inputLoader = FileManager.getInstance().loadInputSWF(this.inputSWF,this.inputSWFLoaded,this.loadErrorHandler);
      }
      
      public function set mouseUpComplete(b:Boolean) : void
      {
         this._mouseUpComplete = b;
      }
      
      public function unloadInputSWF() : void
      {
         try
         {
            this.inputLoader.unload();
            this.inputLoader = null;
         }
         catch(e:Error)
         {
         }
      }
      
      public function get mouseUpComplete() : Boolean
      {
         return this.type == DYNAMIC && !this._mouseUpComplete ? false : this._mouseUpComplete;
      }
      
      public function set lockMouse(b:Boolean) : void
      {
         this._lockMouse = b;
      }
   }
}

