package com.livebrush.tools
{
   import com.livebrush.data.Settings;
   import com.livebrush.graphics.canvas.LineLayer;
   import com.livebrush.styles.Style;
   
   public class BrushGroup
   {
      public var brushes:Array;
      
      public function BrushGroup()
      {
         super();
         this.brushes = [];
      }
      
      public function get lastBrush() : LiveBrush
      {
         return this.brushes[this.brushes.length - 1];
      }
      
      public function removeBrush(id:int) : void
      {
         var index:int = Settings.idToIndex(id.toString(),this.brushes,"id");
         this.brushes[index].die();
         delete this.brushes[index];
         this.brushes.splice(index,1);
      }
      
      public function addBrush(type:String, style:Style, layer:LineLayer) : LiveBrush
      {
         var newBrush:LiveBrush = null;
         newBrush = new LiveBrush(style,layer,layer.canvas.mousePt);
         this.brushes.push(newBrush);
         return newBrush;
      }
      
      public function merge(brushGroup:BrushGroup) : void
      {
         this.brushes = this.brushes.concat(brushGroup.brushes);
      }
   }
}

