package com.livebrush.tools
{
   import com.livebrush.data.Settings;
   import com.livebrush.data.StateManager;
   import com.livebrush.events.CanvasEvent;
   import com.livebrush.graphics.canvas.ColorLayer;
   import flash.events.MouseEvent;
   
   public class ColorLayerTool extends Tool
   {
      public static const NAME:String = "colorLayerTool";
      
      public static const KEY:String = "G";
      
      public function ColorLayerTool(toolMan:ToolManager)
      {
         super(toolMan);
         this.init();
      }
      
      private function init() : void
      {
         name = NAME;
      }
      
      override protected function canvasMouseEvent(e:CanvasEvent) : void
      {
         var layer:ColorLayer = null;
         var d:int = 0;
         var mouseEvent:MouseEvent = e.triggerEvent as MouseEvent;
         var settings:Settings = ui.bucketPropsView.settings;
         if(mouseEvent.type == MouseEvent.MOUSE_DOWN)
         {
            layer = new ColorLayer(canvas,canvasManager.activeLayerDepth + 1);
            layer.color = uint(settings.color);
            layer.alpha = settings.alpha;
            layer.label = settings.color;
            layer.changed = true;
            layer.loaded = true;
            layer.initProps.color = layer.color;
            layer.initProps.alpha = layer.alpha;
            layer.setup();
            canvasManager.addLayer(layer);
            d = layer.depth;
            StateManager.addItem(function(state:Object):void
            {
            },function(state:Object):void
            {
               var l:ColorLayer = state.data.layer;
               l.setXML(state.data.layerXML.toXMLString());
               l.setup();
            },-1,{"layerXML":layer.getXML()},d);
            finish(false);
         }
      }
   }
}

