package com.livebrush.transform
{
   import com.livebrush.graphics.canvas.Canvas;
   import com.livebrush.graphics.canvas.Layer;
   import com.livebrush.tools.Tool;
   import flash.display.Sprite;
   import flash.geom.Point;
   import flash.geom.Rectangle;
   
   public class LayerGroupView extends TransformBoxView
   {
      public var layer:Layer;
      
      public var layerViews:Array;
      
      public function LayerGroupView(tool:Tool, layerViews:Array)
      {
         super(tool,null,true,Canvas.GRAPHIC_REPS,Canvas.CONTROLS,Canvas.WIREFRAME);
         this.layerViews = layerViews;
         this.init();
      }
      
      override protected function init() : void
      {
         this.createView();
         controller = new LayerGroupController(this);
         enableControls();
      }
      
      override public function die() : void
      {
         super.die();
      }
      
      override protected function createView() : void
      {
         var i:int = 0;
         var layerViewBox:Sprite = null;
         var pt:SyncPoint = null;
         var bounds:Rectangle = this.layerViews[0].bounds;
         for(i = 1; i < this.layerViews.length; i++)
         {
            bounds = bounds.union(this.layerViews[i].bounds);
         }
         box = new TransformSprite();
         Canvas.GRAPHIC_REPS.addChild(box);
         box.x = bounds.x;
         box.y = bounds.y;
         for(i = 0; i < this.layerViews.length; i++)
         {
            layerViewBox = this.layerViews[i].box;
            pt = new SyncPoint(Canvas.GRAPHIC_REPS,box,new Point(layerViewBox.x,layerViewBox.y));
            box.addChild(layerViewBox);
            layerViewBox.x = pt.x2;
            layerViewBox.y = pt.y2;
         }
         box.graphics.beginFill(16711680,1);
         box.graphics.drawRect(0,0,bounds.width,bounds.height);
         box.graphics.endFill();
         setupView(box);
      }
      
      override protected function updateBoxView(includeReg:Boolean = true) : void
      {
         if(includeReg)
         {
            updateRegCenter(true);
         }
         for(var i:int = 0; i < 8; i++)
         {
            controlObjs[i].updateSync(true);
         }
         drawBox();
      }
   }
}

