package com.livebrush.transform
{
   import com.livebrush.events.UpdateEvent;
   import com.livebrush.graphics.canvas.Canvas;
   import com.livebrush.graphics.canvas.Layer;
   import com.livebrush.tools.TransformTool;
   import com.livebrush.utils.Update;
   import flash.events.KeyboardEvent;
   import flash.events.MouseEvent;
   import flash.ui.Keyboard;
   
   public class LayerLineController extends TransformBoxController
   {
      public function LayerLineController(view:LayerLineView)
      {
         super(view);
         this.init();
      }
      
      override protected function init() : void
      {
         if(LayerLineView(view).visible)
         {
            this.initKeyControls();
         }
      }
      
      public function get layer() : Layer
      {
         return LayerLineView(view).layer;
      }
      
      private function initKeyControls() : void
      {
         Canvas.STAGE.addEventListener(KeyboardEvent.KEY_DOWN,this.keyHandler);
         Canvas.STAGE.addEventListener(KeyboardEvent.KEY_DOWN,this.keyHandler,true);
      }
      
      override protected function updateModel() : void
      {
         LayerLineView(view).update(new Update(UpdateEvent.GROUP));
         TransformTool(tool).transformLine(LayerLineView(view).getGroupedEdgeUpdateObjs());
      }
      
      override protected function removeMoveLoop() : void
      {
         Canvas.STAGE.removeEventListener(MouseEvent.MOUSE_UP,controlNodeEventHandler);
         Canvas.STAGE.removeEventListener(MouseEvent.MOUSE_MOVE,moveHandler);
      }
      
      private function keyHandler(e:KeyboardEvent) : void
      {
         var char:String = String.fromCharCode(e.charCode).toUpperCase();
         if(e.keyCode == Keyboard.ESCAPE)
         {
            tool.reset();
            tool.setup();
         }
         else if(e.keyCode == Keyboard.DELETE || e.keyCode == Keyboard.BACKSPACE)
         {
            e.stopImmediatePropagation();
            if(LayerLineView(view).groupedEdgeIndices.length > 0)
            {
               tool["deleteEdges"](this.layer,LayerLineView(view).groupedEdgeIndices.items);
            }
         }
      }
      
      override protected function initMoveLoop() : void
      {
         Canvas.STAGE.addEventListener(MouseEvent.MOUSE_MOVE,moveHandler);
         Canvas.STAGE.addEventListener(MouseEvent.MOUSE_UP,controlNodeEventHandler);
      }
      
      override public function die() : void
      {
         Canvas.STAGE.removeEventListener(KeyboardEvent.KEY_DOWN,this.keyHandler);
         Canvas.STAGE.removeEventListener(KeyboardEvent.KEY_DOWN,this.keyHandler,true);
         super.die();
      }
   }
}

