package com.livebrush.transform
{
   import com.livebrush.events.UpdateEvent;
   import com.livebrush.graphics.Edge;
   import com.livebrush.graphics.GraphicUpdate;
   import com.livebrush.graphics.Line;
   import com.livebrush.graphics.SmoothLine;
   import com.livebrush.tools.Tool;
   import com.livebrush.utils.Update;
   import com.livebrush.utils.View;
   
   public class LineWireframeView extends View
   {
      public var wireLine:Line;
      
      public var visible:Boolean;
      
      public var line:Line;
      
      public function LineWireframeView(tool:Tool, line:Line, visible:Boolean = true)
      {
         super(tool);
         this.line = line;
         this.visible = visible;
         this.init();
      }
      
      override public function die() : void
      {
         this.wireLine.die();
      }
      
      override protected function createView() : void
      {
         this.wireLine = this.line.copy(false,true);
      }
      
      public function getEdgeAt(index:int) : Edge
      {
         return this.wireLine.edges[index];
      }
      
      override public function update(update:Update = null) : void
      {
         var i:int = 0;
         if(update.type == UpdateEvent.LINE || update.type == UpdateEvent.LAYER)
         {
            for(i = 0; i < this.line.length; i++)
            {
               this.wireLine.modifyEdge(i,this.line.edges[i].c,this.line.edges[i].a,this.line.edges[i].b);
            }
            if(this.line is SmoothLine)
            {
               this.wireLine.applyProps();
            }
            this.wireLine.drawWireframe();
         }
      }
      
      override protected function init() : void
      {
         this.createView();
         controller = null;
         this.registerController();
         this.update(GraphicUpdate.lineUpdate());
      }
      
      override protected function registerController() : void
      {
      }
   }
}

