package com.livebrush.transform
{
   import com.livebrush.graphics.canvas.Canvas;
   import com.livebrush.graphics.canvas.CanvasManager;
   import com.livebrush.utils.Model;
   import com.livebrush.utils.View;
   import flash.display.DisplayObjectContainer;
   import flash.geom.Point;
   import flash.geom.Rectangle;
   
   public class SelectionView extends View
   {
      private var startPt:Point;
      
      private var endPt:Point;
      
      public function SelectionView(model:Model)
      {
         super(model);
         this.init();
      }
      
      override public function die() : void
      {
         controller.die();
         this.clear();
      }
      
      public function updateSelection(endPt:Point) : void
      {
         this.endPt = endPt;
         Canvas.SELECTION.graphics.clear();
         this.drawBox();
      }
      
      private function drawBox() : void
      {
         var rect:Rectangle = new Rectangle();
         rect.topLeft = this.startPt;
         rect.bottomRight = this.endPt;
         Canvas.SELECTION.graphics.lineStyle(1,16777215,1,false,"none");
         Canvas.SELECTION.graphics.drawRect(rect.x,rect.y,rect.width,rect.height);
      }
      
      public function beginSelection(startPt:Point) : void
      {
         this.startPt = startPt;
      }
      
      public function getSelectionBounds(scope:DisplayObjectContainer) : Rectangle
      {
         return Canvas.SELECTION.getBounds(scope).clone();
      }
      
      public function clear() : void
      {
         Canvas.SELECTION.graphics.clear();
         this.startPt = null;
      }
      
      override protected function init() : void
      {
         this.createController();
      }
      
      public function get canvasManager() : CanvasManager
      {
         return CanvasManager(model);
      }
      
      override protected function createController() : void
      {
         controller = new SelectionController(this);
      }
   }
}

