package com.livebrush.transform
{
   import com.livebrush.graphics.Edge;
   import com.livebrush.graphics.GraphicUpdate;
   import com.livebrush.graphics.canvas.LineLayer;
   import com.livebrush.tools.Tool;
   import com.livebrush.utils.Update;
   
   public class SingleEdgeView extends EdgeView
   {
      public var enabled:Boolean;
      
      private var singleEdge:Edge;
      
      public function SingleEdgeView(tool:Tool, layer:LineLayer, edge:Edge, enabled:Boolean = true)
      {
         super(tool,layer,0);
         this.singleEdge = edge;
         this.enabled = enabled;
         this.initSingle();
      }
      
      override protected function init() : void
      {
      }
      
      private function initSingle() : void
      {
         createView();
         createController();
         if(this.enabled)
         {
            registerController();
         }
         this.update(GraphicUpdate.layerUpdate());
      }
      
      override public function update(update:Update = null) : void
      {
         posObj.child1Pos = this.edge.c;
         widthObj1.child1Pos = this.edge.a;
         widthObj2.child1Pos = this.edge.b;
         drawEdge();
      }
      
      override public function get edge() : Edge
      {
         return this.singleEdge;
      }
   }
}

