package com.livebrush.transform
{
   import flash.display.DisplayObjectContainer;
   import flash.geom.Point;
   
   public class SyncPoint
   {
      private var _doc1Pt:Point;
      
      private var _doc2:DisplayObjectContainer;
      
      private var _doc1:DisplayObjectContainer;
      
      private var _doc2Pt:Point;
      
      public function SyncPoint(doc1:DisplayObjectContainer, doc2:DisplayObjectContainer, doc1Pt:Point = null, doc2Pt:Point = null)
      {
         super();
         this._doc1 = doc1;
         this._doc2 = doc2;
         this._doc1Pt = doc1Pt != null ? doc1Pt : new Point();
         this.doc1Pt = doc1Pt;
      }
      
      private static function _localToLocal(pt:Point, fromScope:DisplayObjectContainer, toScope:DisplayObjectContainer) : Point
      {
         if(fromScope.stage == null || toScope.stage == null)
         {
            throw new Error("SyncPoint display objects containers need to be on the display list. (fromScope.stage=" + fromScope.stage + ", toScope.stage=" + toScope.stage + ")");
         }
         pt = fromScope.localToGlobal(pt);
         return toScope.globalToLocal(pt);
      }
      
      public static function localToLocal(pt:Point, fromScope:DisplayObjectContainer, toScope:DisplayObjectContainer) : Point
      {
         return _localToLocal(pt,fromScope,toScope);
      }
      
      public static function objToPoint(obj:Object) : Point
      {
         return new Point(obj.x,obj.y);
      }
      
      public function get x1() : Number
      {
         return this._doc1Pt.x;
      }
      
      public function set doc1Pt(pt:Point) : void
      {
         this._doc1Pt = pt;
         this.update(true);
      }
      
      public function get x2() : Number
      {
         return this._doc2Pt.x;
      }
      
      public function set y2(n:Number) : void
      {
         this._doc2Pt.y = n;
         this.update(false);
      }
      
      private function init() : void
      {
      }
      
      public function set doc1(doc:DisplayObjectContainer) : *
      {
         this._doc1 = doc;
         this.update(false);
      }
      
      public function get y1() : Number
      {
         return this._doc1Pt.y;
      }
      
      public function get doc1Pt() : Point
      {
         return this._doc1Pt;
      }
      
      public function get doc2Pt() : Point
      {
         return this._doc2Pt;
      }
      
      public function get y2() : Number
      {
         return this._doc2Pt.y;
      }
      
      public function update(fromDoc1:Boolean) : void
      {
         if(fromDoc1)
         {
            this._doc2Pt = _localToLocal(this._doc1Pt,this._doc1,this._doc2);
         }
         else
         {
            this._doc1Pt = _localToLocal(this._doc2Pt,this._doc2,this._doc1);
         }
      }
      
      public function set x1(n:Number) : void
      {
         this._doc1Pt.x = n;
         this.update(true);
      }
      
      public function set doc2(doc:DisplayObjectContainer) : *
      {
         this._doc2 = doc;
         this.update(true);
      }
      
      public function set y1(n:Number) : void
      {
         this._doc1Pt.y = n;
         this.update(true);
      }
      
      public function get doc1() : DisplayObjectContainer
      {
         return this._doc1;
      }
      
      public function get doc2() : DisplayObjectContainer
      {
         return this._doc2;
      }
      
      public function set x2(n:Number) : void
      {
         this._doc2Pt.x = n;
         this.update(false);
      }
      
      public function set doc2Pt(pt:Point) : void
      {
         this._doc2Pt = pt;
         this.update(false);
      }
   }
}

