package com.livebrush.transform
{
   import com.livebrush.tools.TransformTool;
   import com.livebrush.utils.Controller;
   import flash.display.DisplayObjectContainer;
   import flash.events.Event;
   import flash.events.MouseEvent;
   import flash.geom.Point;
   
   public class TransformBoxController extends Controller
   {
      public static const NONE:String = "none";
      
      public static const MOVE:String = "move";
      
      public static const ROTATE:String = "rotate";
      
      public static const SCALE:String = "scale";
      
      public static const SKEW:String = "skew";
      
      public static const MOVE_CENTER:String = "moveCenter";
      
      private var iAngleRads:Number;
      
      private var iSlope:Number;
      
      private var iSize:Point;
      
      private var scalePoints:Object;
      
      private var iSkew:Point;
      
      private var controlNodes:Array;
      
      private var skewPoints:Object;
      
      private var iScale:Point;
      
      private var iNeg:Object;
      
      private var activeNode:ControlNodeAsset2;
      
      private var mouseEvent:MouseEvent;
      
      private var action:String;
      
      private var scaleFactor:Number;
      
      private var controlNode:ControlNodeAsset2;
      
      public function TransformBoxController(view:TransformBoxView)
      {
         super(view);
         this.iNeg = {};
         this.controlNodes = [];
         this.iSize = new Point();
         this.iScale = new Point();
         this.init();
      }
      
      override public function die() : void
      {
         var tempNodes:Array = null;
         var i:int = 0;
         if(this.controlNodes.length > 0)
         {
            tempNodes = this.controlNodes.slice();
            for(i = 0; i < tempNodes.length; i++)
            {
               this.unregisterNode(tempNodes[i]);
            }
            tempNodes = [];
            this.controlNodes = [];
         }
      }
      
      private function isCornerNode() : Boolean
      {
         return this.activeNode != this.boxView.topCenter.child2 && this.activeNode != this.boxView.bottomCenter.child2 && this.activeNode != this.boxView.leftCenter.child2 && this.activeNode != this.boxView.rightCenter.child2;
      }
      
      private function getSkewPoints(controlNode:ControlNodeAsset2 = null) : Object
      {
         var skewPoints:Object = {};
         var _loc3_:* = controlNode;
         switch(0)
         {
         }
         return {
            "pt1":this.boxView.actualCenter,
            "pt2":this.boxView.actualCenter
         };
      }
      
      public function registerNode(controlNode:DisplayObjectContainer) : void
      {
         controlNode.addEventListener(MouseEvent.MOUSE_DOWN,this.controlNodeEventHandler);
         this.controlNodes.push(controlNode);
      }
      
      protected function controlNodeEventHandler(e:MouseEvent) : void
      {
         var controlPt:Point = null;
         var neg:Number = NaN;
         this.mouseEvent = e;
         try
         {
            if(e.type == MouseEvent.MOUSE_DOWN)
            {
               e.stopImmediatePropagation();
               this.tool.begin();
               if(e.target.name == "regNode")
               {
                  this.boxView.regNode.startDrag();
                  this.action = MOVE_CENTER;
               }
               else if(e.target is ControlNodeAsset2 && e.ctrlKey || e.target is ControlNodeAsset2 && !this.tool.scaleAllowed)
               {
                  this.iAngleRads = this.rotAngle(this.boxView.box.rotation * Math.PI / 180);
                  this.action = ROTATE;
               }
               else if(e.target is ControlNodeAsset2)
               {
                  controlPt = new Point(this.boxView.controlSprite.mouseX,this.boxView.controlSprite.mouseY);
                  this.activeNode = ControlNodeAsset2(e.target);
                  this.iScale = new Point(this.boxView.box.scaleX,this.boxView.box.scaleY);
                  if(!this.mouseEvent.shiftKey && !this.tool.constrain)
                  {
                     this.scalePoints = this.getScalePoints(this.activeNode);
                  }
                  else
                  {
                     this.scalePoints = this.getScalePoints();
                  }
                  this.iSize.x = Point.distance(controlPt,this.scalePoints.width.child2Pos);
                  this.iSize.y = Point.distance(controlPt,this.scalePoints.height.child2Pos);
                  neg = this.boxView.box.mouseX - this.boxView.regCenter.child1X;
                  this.iNeg.x = neg == Math.abs(neg) ? 1 : -1;
                  neg = this.boxView.box.mouseY - this.boxView.regCenter.child1Y;
                  this.iNeg.y = neg == Math.abs(neg) ? 1 : -1;
                  this.action = SCALE;
               }
               else if(this.boxView.box.hitTestPoint(e.stageX,e.stageY,true))
               {
                  this.action = MOVE;
                  this.boxView.box.startDrag();
               }
               this.initMoveLoop();
            }
            else if(e.type == MouseEvent.MOUSE_UP)
            {
               this.removeMoveLoop();
               this.boxView.box.stopDrag();
               this.boxView.regNode.stopDrag();
               this.action = NONE;
               this.tool.finish();
            }
         }
         catch(e:Error)
         {
         }
      }
      
      protected function initMoveLoop() : void
      {
         this.boxView.box.stage.addEventListener(MouseEvent.MOUSE_MOVE,this.moveHandler);
         this.boxView.box.stage.addEventListener(MouseEvent.MOUSE_UP,this.controlNodeEventHandler);
      }
      
      protected function moveHandler(e:Event) : void
      {
         var pt:Point = null;
         var pt1:* = undefined;
         var pt2:* = undefined;
         var neg:Object = null;
         var flipped:Boolean = false;
         var num:Number = NaN;
         var scale:Number = NaN;
         var angleRads:Number = NaN;
         var controlPt:Point = new Point(this.boxView.controlSprite.mouseX,this.boxView.controlSprite.mouseY);
         var size:Point = new Point();
         try
         {
            if(this.action != MOVE)
            {
               if(this.action == SCALE)
               {
                  pt = this.boxView.regNode.parent.localToGlobal(this.boxView.regCenter.child2Pos);
                  if(!this.boxView.box.hitTestPoint(pt.x,pt.y,true))
                  {
                     if(!this.mouseEvent.shiftKey)
                     {
                        this.scalePoints = this.getScalePoints(this.activeNode);
                     }
                     else
                     {
                        this.scalePoints = this.getScalePoints();
                     }
                  }
                  size.x = Point.distance(controlPt,this.scalePoints.width.child2Pos);
                  size.y = Point.distance(controlPt,this.scalePoints.height.child2Pos);
                  pt1 = controlPt.x - this.scalePoints.width.child2X;
                  pt2 = size.x;
                  neg = {};
                  neg.x = this.boxView.box.mouseX - this.boxView.regCenter.child1X;
                  neg.y = this.boxView.box.mouseY - this.boxView.regCenter.child1Y;
                  flipped = neg.x * this.iNeg.x != Math.abs(neg.x) || neg.y * this.iNeg.y != Math.abs(neg.y);
                  num = neg.x * this.iNeg.x;
                  num = neg.y * this.iNeg.y;
                  if(!this.isHeightNode() && !flipped || !this.isCornerNode() && !this.isHeightNode())
                  {
                     scale = this.iScale.x * (size.x / this.iSize.x);
                     this.boxView.box.scaleX2 = scale;
                  }
                  if(!this.isWidthNode() && !flipped || !this.isCornerNode() && !this.isWidthNode())
                  {
                     scale = this.iScale.y * (size.y / this.iSize.y);
                     this.boxView.box.scaleY2 = scale;
                  }
               }
               else if(this.action != SKEW)
               {
                  if(this.action == ROTATE)
                  {
                     angleRads = this.rotAngle(this.iAngleRads);
                     this.boxView.box.rotation2 = angleRads * 180 / Math.PI;
                  }
                  else if(this.action == MOVE_CENTER)
                  {
                     this.boxView.updateRegCenter(false);
                  }
               }
            }
            this.updateModel();
         }
         catch(e:Error)
         {
         }
      }
      
      protected function removeMoveLoop() : void
      {
         this.boxView.box.stage.removeEventListener(MouseEvent.MOUSE_UP,this.controlNodeEventHandler);
         this.boxView.box.stage.removeEventListener(MouseEvent.MOUSE_MOVE,this.moveHandler);
      }
      
      public function get tool() : TransformTool
      {
         return TransformTool(this.boxView.tool);
      }
      
      private function getScalePoints(controlNode:ControlNodeAsset2 = null) : Object
      {
         var scalePoints:Object = {};
         switch(controlNode)
         {
            case this.boxView.bottomRight.child2:
               scalePoints = {
                  "width":this.boxView.bottomReg,
                  "height":this.boxView.rightReg
               };
               break;
            case this.boxView.bottomLeft.child2:
               scalePoints = {
                  "width":this.boxView.bottomReg,
                  "height":this.boxView.leftReg
               };
               break;
            case this.boxView.topLeft.child2:
               scalePoints = {
                  "width":this.boxView.topReg,
                  "height":this.boxView.leftReg
               };
               break;
            case this.boxView.topRight.child2:
               scalePoints = {
                  "width":this.boxView.topReg,
                  "height":this.boxView.rightReg
               };
               break;
            case this.boxView.topCenter.child2:
               scalePoints = {
                  "width":this.boxView.topCenter,
                  "height":this.boxView.regCenter
               };
               break;
            case this.boxView.bottomCenter.child2:
               scalePoints = {
                  "width":this.boxView.bottomCenter,
                  "height":this.boxView.regCenter
               };
               break;
            case this.boxView.leftCenter.child2:
               scalePoints = {
                  "width":this.boxView.regCenter,
                  "height":this.boxView.leftCenter
               };
               break;
            case this.boxView.rightCenter.child2:
               scalePoints = {
                  "width":this.boxView.regCenter,
                  "height":this.boxView.rightCenter
               };
               break;
            default:
               scalePoints = {
                  "width":this.boxView.regCenter,
                  "height":this.boxView.regCenter
               };
         }
         return scalePoints;
      }
      
      public function unregisterNode(controlNode:DisplayObjectContainer) : void
      {
         controlNode.removeEventListener(MouseEvent.MOUSE_DOWN,this.controlNodeEventHandler);
         this.controlNodes.splice(this.controlNodes.indexOf(controlNode),1);
      }
      
      public function get boxView() : TransformBoxView
      {
         return TransformBoxView(view);
      }
      
      override protected function updateModel() : void
      {
      }
      
      private function isHeightNode() : Boolean
      {
         return this.activeNode == this.boxView.topCenter.child2 || this.activeNode == this.boxView.bottomCenter.child2;
      }
      
      private function isWidthNode() : Boolean
      {
         return this.activeNode == this.boxView.leftCenter.child2 || this.activeNode == this.boxView.rightCenter.child2;
      }
      
      private function getControlNode(controlNode:ControlNodeAsset2) : ControlNodeAsset2
      {
         switch(controlNode)
         {
            case this.boxView.topCenter.child2:
               controlNode = ControlNodeAsset2(this.boxView.topReg.child2);
               break;
            case this.boxView.bottomCenter.child2:
               controlNode = ControlNodeAsset2(this.boxView.bottomReg.child2);
               break;
            case this.boxView.leftCenter.child2:
               controlNode = ControlNodeAsset2(this.boxView.leftReg.child2);
               break;
            case this.boxView.rightCenter.child2:
               controlNode = ControlNodeAsset2(this.boxView.rightReg.child2);
         }
         return controlNode;
      }
      
      private function rotAngle(offset:Number = 0) : Number
      {
         return Math.atan2(this.boxView.controlSprite.mouseY - this.boxView.regCenter.child2Y,this.boxView.controlSprite.mouseX - this.boxView.regCenter.child2X) - offset;
      }
      
      override protected function init() : void
      {
      }
   }
}

