package com.livebrush.transform
{
   import flash.display.Sprite;
   import flash.geom.Matrix;
   import flash.geom.Point;
   
   public class TransformSprite extends Sprite
   {
      private var _rp:Point;
      
      public function TransformSprite()
      {
         super();
         this.setRegistration();
      }
      
      public function get x2() : Number
      {
         var p:Point = this.parent.globalToLocal(this.localToGlobal(this._rp));
         return p.x;
      }
      
      public function get scaleY2() : Number
      {
         return this.scaleY;
      }
      
      public function get scaleX2() : Number
      {
         return this.scaleX;
      }
      
      public function set scaleY2(value:Number) : void
      {
         this.setProperty2("scaleY",value);
      }
      
      public function set scaleX2(value:Number) : void
      {
         this.setProperty2("scaleX",value);
      }
      
      public function scale(x:Number, y:Number) : void
      {
         var a:Point = this.parent.globalToLocal(this.localToGlobal(this._rp));
         this.scaleX = x;
         this.scaleY = y;
         var b:Point = this.parent.globalToLocal(this.localToGlobal(this._rp));
         this.x -= b.x - a.x;
         this.y -= b.y - a.y;
      }
      
      public function translate(x:Number, y:Number) : void
      {
         var p:Point = this.parent.globalToLocal(this.localToGlobal(this._rp));
         this.x += x - p.x;
         this.y += y - p.y;
      }
      
      public function set rotation2(value:Number) : void
      {
         this.setProperty2("rotation",value);
      }
      
      public function setRegistration(x:Number = 0, y:Number = 0) : void
      {
         this._rp = new Point(x,y);
      }
      
      public function set y2(value:Number) : void
      {
         var p:Point = this.parent.globalToLocal(this.localToGlobal(this._rp));
         this.y += value - p.y;
      }
      
      public function set x2(value:Number) : void
      {
         var p:Point = this.parent.globalToLocal(this.localToGlobal(this._rp));
         this.x += value - p.x;
      }
      
      public function setRegistrationPoint(pt:Point) : void
      {
         this._rp = pt;
      }
      
      public function setProperty2(prop:String, n:Number) : void
      {
         var a:Point = this.parent.globalToLocal(this.localToGlobal(this._rp));
         this[prop] = n;
         var b:Point = this.parent.globalToLocal(this.localToGlobal(this._rp));
         this.x -= b.x - a.x;
         this.y -= b.y - a.y;
      }
      
      public function get y2() : Number
      {
         var p:Point = this.parent.globalToLocal(this.localToGlobal(this._rp));
         return p.y;
      }
      
      public function get rotation2() : Number
      {
         return this.rotation;
      }
      
      public function set skewX(n:Number) : void
      {
         var a:Point = this.parent.globalToLocal(this.localToGlobal(this._rp));
         var mat:Matrix = transform.matrix;
         mat.c = n;
         transform.matrix = mat;
         var b:Point = this.parent.globalToLocal(this.localToGlobal(this._rp));
         this.x -= b.x - a.x;
      }
      
      public function get mouseY2() : Number
      {
         return Math.round(this.mouseY - this._rp.y);
      }
      
      public function get mouseX2() : Number
      {
         return Math.round(this.mouseX - this._rp.x);
      }
   }
}

