package com.livebrush.ui
{
   import com.livebrush.data.Settings;
   import com.livebrush.styles.*;
   import flash.display.Sprite;
   import flash.events.MouseEvent;
   
   public class BrushPropsController extends UIController
   {
      public function BrushPropsController(brushPropsView:BrushPropsView)
      {
         super(brushPropsView);
         this.init();
      }
      
      private function get lineStyleView() : LineStyleView
      {
         return this.brushPropsModel.lineStyleView;
      }
      
      private function get uiAsset() : Sprite
      {
         return this.brushPropsView.uiAsset;
      }
      
      private function get decoStyle() : DecoStyle
      {
         return this.activeStyle.decoStyle;
      }
      
      private function get decoStyleView() : DecoStyleView
      {
         return this.brushPropsModel.decoStyleView;
      }
      
      private function get brushBehaveView() : BrushBehaveView
      {
         return this.brushPropsModel.brushBehaveView;
      }
      
      public function get activeStyle() : Style
      {
         return this.styleManager.activeStyle;
      }
      
      override protected function init() : void
      {
         this.uiAsset.addEventListener(MouseEvent.CLICK,this.mouseEvent);
      }
      
      private function get brushPropsModel() : BrushPropsModel
      {
         return this.brushPropsView.brushPropsModel;
      }
      
      private function mouseEvent(e:MouseEvent) : void
      {
         var tabIndex:int = 0;
         var settings:Settings = null;
         if(e.target.name.indexOf("tab") > -1)
         {
            tabIndex = int(e.target.name.substr(3));
            this.brushPropsModel.toggleProps(tabIndex);
         }
         else if(e.target.name.indexOf("help") > -1)
         {
            switch(e.target.parent.name)
            {
               case "behaveTypeHead":
                  ui.loadHelp("behaveType");
                  break;
               case "liveControlHead":
                  ui.loadHelp("liveControls");
                  break;
               case "thresholdsHead":
                  ui.loadHelp("decoThresholds");
                  break;
               case "drawSpeedHead":
                  ui.loadHelp("drawSpeed");
                  break;
               case "lineTypeHead":
                  ui.loadHelp("lineType");
                  break;
               case "strokeTypeHead":
                  ui.loadHelp("strokeType");
                  break;
               case "lineWidthHead":
                  ui.loadHelp("lineWidth");
                  break;
               case "lineAngleHead":
                  ui.loadHelp("lineAngle");
                  break;
               case "lineAlphaHead":
                  ui.loadHelp("lineOpacity");
                  break;
               case "lineColorHead":
                  ui.loadHelp("lineColors");
                  break;
               case "decoListHead":
                  ui.loadHelp("decoList");
                  break;
               case "decoAlignHead":
                  ui.loadHelp("decoAlignType");
                  break;
               case "decoPositionHead":
                  ui.loadHelp("decoPosition");
                  break;
               case "decoAngleHead":
                  ui.loadHelp("decoAngle");
                  break;
               case "decoSizeHead":
                  ui.loadHelp("decoScale");
                  break;
               case "decoAlphaHead":
                  ui.loadHelp("decoOpacity");
                  break;
               case "decoTintHead":
                  ui.loadHelp("decoColorAmount");
                  break;
               case "decoColorHead":
                  ui.loadHelp("decoColors");
            }
         }
         else if(e.target.name.indexOf("reset") > -1)
         {
            if(e.target.parent.name == "behaveTypeHead")
            {
               settings = this.lineStyle.settings;
               settings.type = this.lineStyle.defaultSettings.type;
               this.lineStyle.settings = settings;
            }
            else if(e.target.parent.name == "liveControlHead")
            {
               settings = this.lineStyle.settings;
               settings.elastic = this.lineStyle.defaultSettings.elastic;
               settings.friction = this.lineStyle.defaultSettings.friction;
               this.lineStyle.settings = settings;
            }
            else if(e.target.parent.name == "thresholdsHead")
            {
               settings = this.strokeStyle.settings;
               settings.thresholds = this.strokeStyle.defaultSettings.thresholds;
               this.strokeStyle.settings = settings;
            }
            else if(e.target.parent.name == "drawSpeedHead")
            {
               settings = this.lineStyle.settings;
               settings.minDrawSpeed = this.lineStyle.defaultSettings.minDrawSpeed;
               settings.maxDrawSpeed = this.lineStyle.defaultSettings.maxDrawSpeed;
               this.lineStyle.settings = settings;
            }
            else if(e.target.parent.name == "lineTypeHead")
            {
               settings = this.lineStyle.settings;
               settings.smoothing = this.lineStyle.defaultSettings.smoothing;
               this.lineStyle.settings = settings;
            }
            else if(e.target.parent.name == "strokeTypeHead")
            {
               settings = this.strokeStyle.settings;
               settings.strokeType = this.strokeStyle.defaultSettings.strokeType;
               settings.lines = this.strokeStyle.defaultSettings.lines;
               settings.weight = this.strokeStyle.defaultSettings.weight;
               this.strokeStyle.settings = settings;
            }
            else if(e.target.parent.name == "lineWidthHead")
            {
               settings = this.strokeStyle.settings;
               settings.widthType = this.strokeStyle.defaultSettings.widthType;
               settings.minWidth = this.strokeStyle.defaultSettings.minWidth;
               settings.maxWidth = this.strokeStyle.defaultSettings.maxWidth;
               settings.widthSpeed = this.strokeStyle.defaultSettings.widthSpeed;
               this.strokeStyle.settings = settings;
            }
            else if(e.target.parent.name == "lineAngleHead")
            {
               settings = this.strokeStyle.settings;
               settings.angleType = this.strokeStyle.defaultSettings.angleType;
               settings.minAngle = this.strokeStyle.defaultSettings.minAngle;
               settings.maxAngle = this.strokeStyle.defaultSettings.maxAngle;
               settings.angleSpeed = this.strokeStyle.defaultSettings.angleSpeed;
               this.strokeStyle.settings = settings;
            }
            else if(e.target.parent.name == "lineAlphaHead")
            {
               settings = this.strokeStyle.settings;
               settings.alphaType = this.strokeStyle.defaultSettings.alphaType;
               settings.minAlpha = this.strokeStyle.defaultSettings.minAlpha;
               settings.maxAlpha = this.strokeStyle.defaultSettings.maxAlpha;
               settings.alphaSpeed = this.strokeStyle.defaultSettings.alphaSpeed;
               this.strokeStyle.settings = settings;
            }
            else if(e.target.parent.name == "lineColorHead")
            {
               settings = this.strokeStyle.settings;
               settings.colorObjList = this.strokeStyle.defaultSettings.colorObjList;
               settings.colorType = this.strokeStyle.defaultSettings.colorType;
               settings.colorSteps = this.strokeStyle.defaultSettings.colorSteps;
               this.strokeStyle.settings = settings;
            }
            else if(e.target.parent.name == "decoListHead")
            {
               settings = this.decoStyle.settings;
               settings.decos = this.decoStyle.defaultSettings.decos;
               settings.selectedDecoIndex = this.decoStyle.defaultSettings.selectedDecoIndex;
               settings.orderType = this.decoStyle.defaultSettings.orderType;
               settings.decoNum = this.decoStyle.defaultSettings.decoNum;
               this.decoStyle.settings = settings;
            }
            else if(e.target.parent.name == "decoAlignHead")
            {
               settings = this.decoStyle.settings;
               settings.autoFlip = this.decoStyle.defaultSettings.autoFlip;
               settings.alignType = this.decoStyle.defaultSettings.alignType;
               this.decoStyle.settings = settings;
            }
            else if(e.target.parent.name == "decoPositionHead")
            {
               settings = this.decoStyle.settings;
               settings.posType = this.decoStyle.defaultSettings.posType;
               settings.minPos = this.decoStyle.defaultSettings.minPos;
               settings.maxPos = this.decoStyle.defaultSettings.maxPos;
               settings.posSpeed = this.decoStyle.defaultSettings.posSpeed;
               this.decoStyle.settings = settings;
            }
            else if(e.target.parent.name == "decoAngleHead")
            {
               settings = this.decoStyle.settings;
               settings.angleType = this.decoStyle.defaultSettings.angleType;
               settings.minAngle = this.decoStyle.defaultSettings.minAngle;
               settings.maxAngle = this.decoStyle.defaultSettings.maxAngle;
               settings.angleSpeed = this.decoStyle.defaultSettings.angleSpeed;
               this.decoStyle.settings = settings;
            }
            else if(e.target.parent.name == "decoSizeHead")
            {
               settings = this.decoStyle.settings;
               settings.sizeType = this.decoStyle.defaultSettings.sizeType;
               settings.minSize = this.decoStyle.defaultSettings.minSize;
               settings.maxSize = this.decoStyle.defaultSettings.maxSize;
               settings.sizeSpeed = this.decoStyle.defaultSettings.sizeSpeed;
               this.decoStyle.settings = settings;
            }
            else if(e.target.parent.name == "decoAlphaHead")
            {
               settings = this.decoStyle.settings;
               settings.alphaType = this.decoStyle.defaultSettings.alphaType;
               settings.minAlpha = this.decoStyle.defaultSettings.minAlpha;
               settings.maxAlpha = this.decoStyle.defaultSettings.maxAlpha;
               settings.alphaSpeed = this.decoStyle.defaultSettings.alphaSpeed;
               this.decoStyle.settings = settings;
            }
            else if(e.target.parent.name == "decoTintHead")
            {
               settings = this.decoStyle.settings;
               settings.tintType = this.decoStyle.defaultSettings.tintType;
               settings.minTint = this.decoStyle.defaultSettings.minTint;
               settings.maxTint = this.decoStyle.defaultSettings.maxTint;
               settings.tintSpeed = this.decoStyle.defaultSettings.tintSpeed;
               this.decoStyle.settings = settings;
            }
            else if(e.target.parent.name == "decoColorHead")
            {
               settings = this.decoStyle.settings;
               settings.colorObjList = this.decoStyle.defaultSettings.colorObjList;
               settings.colorType = this.decoStyle.defaultSettings.colorType;
               settings.colorSteps = this.decoStyle.defaultSettings.colorSteps;
               this.decoStyle.settings = settings;
            }
            this.styleManager.pushStyle();
         }
      }
      
      private function get strokeStyle() : StrokeStyle
      {
         return this.activeStyle.strokeStyle;
      }
      
      private function get brushPropsView() : BrushPropsView
      {
         return BrushPropsView(view);
      }
      
      public function get styleManager() : StyleManager
      {
         return this.brushPropsModel.styleManager;
      }
      
      private function get lineStyle() : LineStyle
      {
         return this.activeStyle.lineStyle;
      }
   }
}

