package com.livebrush.ui
{
   import com.livebrush.data.Settings;
   import com.livebrush.events.UpdateEvent;
   import com.livebrush.utils.Update;
   import fl.controls.ScrollPolicy;
   
   public class BrushPropsView extends UIView
   {
      public var brushPropsModel:BrushPropsModel;
      
      public var uiAsset:BrushToolPropsUI;
      
      public var tabs:Array;
      
      public function BrushPropsView(brushPropsModel:BrushPropsModel)
      {
         super(brushPropsModel.ui);
         helpID = "brushTool";
         this.brushPropsModel = brushPropsModel;
         init();
      }
      
      private function toggleTab(index:int) : void
      {
         for(var i:int = 0; i < 3; i++)
         {
            this.uiAsset.addChildAt(this.tabs[i],2 - i);
         }
         this.uiAsset.addChildAt(this.tabs[index],2);
      }
      
      override protected function createView() : void
      {
         this.uiAsset = new BrushToolPropsUI();
         this.uiAsset.cacheAsBitmap = true;
         this.tabs = [this.uiAsset.tab0,this.uiAsset.tab1,this.uiAsset.tab2];
         this.uiAsset.swapChildrenAt(0,this.uiAsset.getChildIndex(this.uiAsset.tab0));
         this.uiAsset.swapChildrenAt(1,this.uiAsset.getChildIndex(this.uiAsset.tab1));
         this.uiAsset.swapChildrenAt(2,this.uiAsset.getChildIndex(this.uiAsset.tab2));
         this.uiAsset.contentHolder.horizontalScrollPolicy = ScrollPolicy.OFF;
         this.uiAsset.contentHolder.verticalScrollPolicy = ScrollPolicy.ON;
      }
      
      override public function update(update:Update = null) : void
      {
         if(update.type == UpdateEvent.WINDOW || update.type == UpdateEvent.UI)
         {
            try
            {
               this.uiAsset.contentHolder.height = ui.toolPropsView.panelAsset.height - 52;
               this.uiAsset.contentHolder.drawNow();
            }
            catch(e:Error)
            {
            }
            try
            {
               this.toggleTab(this.brushPropsModel.currentGroup);
               this.uiAsset.contentHolder.source = this.brushPropsModel.propGroups[this.brushPropsModel.currentGroup].uiAsset;
            }
            catch(e:Error)
            {
            }
         }
         else if(update.type == UpdateEvent.BRUSH_STYLE)
         {
            this.pushProps(Settings(update.data));
         }
      }
      
      private function pushProps(data:Settings) : void
      {
      }
      
      override protected function createController() : void
      {
         controller = new BrushPropsController(this);
      }
   }
}

