package com.livebrush.ui
{
   import com.livebrush.events.ListEvent;
   import fl.controls.CheckBox;
   import fl.controls.ColorPicker;
   import flash.display.DisplayObjectContainer;
   import flash.display.MovieClip;
   import flash.events.Event;
   import flash.events.MouseEvent;
   import flash.geom.ColorTransform;
   
   public class ColorListItem extends RichListItem
   {
      private var _cf:ColorTransform;
      
      public var colorBg:MovieClip;
      
      public var enabledUI:CheckBox;
      
      private var _colorHexValue:String = "FFFFFF";
      
      private var _active:Boolean = true;
      
      public var colorInput:ColorInput;
      
      private var _colorValue:uint = 16777215;
      
      public function ColorListItem(parent:DisplayObjectContainer, y:Number = 0)
      {
         super(parent,y,ColorListItemUI);
         this.init();
      }
      
      private function _setColor(c:uint) : void
      {
         this.colorInput.color = c;
         this.colorBg.transform.colorTransform = this.colorInput.colorTransform;
      }
      
      public function get enabled() : Boolean
      {
         return this.enabledUI.selected;
      }
      
      public function set color(u:uint) : void
      {
         this._setColor(u);
      }
      
      public function set enabled(b:Boolean) : void
      {
         this.enabledUI.selected = b;
      }
      
      override protected function _mouseClick(e:MouseEvent) : void
      {
         if(e.target == highlight || e.target == this.colorBg || e.target == uiAsset["_label"])
         {
            dispatchEvent(new ListEvent(ListEvent.SELECT));
         }
      }
      
      private function init() : void
      {
         this.colorInput = uiAsset["_colorInput"];
         this.enabledUI = uiAsset["_enabled"];
         this.colorBg = uiAsset["_colorBg"];
         uiAsset.addEventListener(Event.CHANGE,this.itemChange);
      }
      
      override protected function _setSelected(b:Boolean) : void
      {
         if(b)
         {
            highlight.alpha = 1;
            _selected = b;
         }
         else
         {
            _selected = b;
            _mouseOut();
         }
      }
      
      public function get color() : uint
      {
         return this.colorInput.color;
      }
      
      override protected function _mouseOver() : void
      {
      }
      
      override protected function _setData(o:Object) : void
      {
         this._setColor(o.value);
         this.enabled = o.enabled;
      }
      
      private function itemChange(e:Event) : void
      {
         if(e.target is ColorPicker)
         {
            this._setColor(this.colorInput.color);
         }
         data.value = this.color;
         data.enabled = this.enabled;
      }
   }
}

