package com.livebrush.ui
{
   import com.livebrush.data.FileManager;
   import com.livebrush.events.ListEvent;
   import com.livebrush.utils.ColorObj;
   import flash.events.Event;
   
   public class DecoStyleController extends UIController
   {
      public function DecoStyleController(decoStyleView:DecoStyleView)
      {
         super(decoStyleView);
         this.init();
      }
      
      override protected function init() : void
      {
         this.uiAsset.addEventListener(Event.CHANGE,this.propsChangeEvent);
         this.uiAsset.positionInputs.addEventListener(Event.CHANGE,this.propsChangeEvent);
         this.uiAsset.angleInputs.addEventListener(Event.CHANGE,this.propsChangeEvent);
         this.uiAsset.sizeInputs.addEventListener(Event.CHANGE,this.propsChangeEvent);
         this.uiAsset.alphaInputs.addEventListener(Event.CHANGE,this.propsChangeEvent);
         this.uiAsset.tintInputs.addEventListener(Event.CHANGE,this.propsChangeEvent);
         this.uiAsset.alignInputs.addEventListener(Event.CHANGE,this.propsChangeEvent);
         this.decoStyleView.colorInputs.addEventListener(ListEvent.ADD,this.addColor);
         this.decoStyleView.colorInputs.addEventListener(ListEvent.REMOVE,this.removeColor);
         this.decoStyleView.colorInputs.addEventListener(Event.CHANGE,this.propsChangeEvent);
         this.decoStyleView.decoInputs.addEventListener(ListEvent.ADD,this.addDeco);
         this.decoStyleView.decoInputs.addEventListener(ListEvent.REMOVE,this.removeDeco);
         this.decoStyleView.decoInputs.addEventListener(Event.CHANGE,this.propsChangeEvent);
      }
      
      private function propsChangeEvent(e:Event) : void
      {
         e.stopImmediatePropagation();
         this.decoStyleView.applyProps();
         this.brushPropsModel.pullStyleProps();
      }
      
      private function addColor(e:ListEvent) : void
      {
         try
         {
            this.decoStyleView.colorInputs.addItemAt(this.decoStyleView.colorInputs.list[this.decoStyleView.colorInputs.selectedIndex].copy(),this.decoStyleView.colorInputs.selectedIndex);
         }
         catch(e:Error)
         {
            decoStyleView.colorInputs.addItemAt(decoStyleView.colorInputs.list[0].copy(),0);
         }
         catch(e:Error)
         {
            decoStyleView.colorInputs.addItemAt(new ColorObj(16711680,true),0);
         }
      }
      
      private function get brushPropsModel() : BrushPropsModel
      {
         return this.decoStyleView.brushPropsModel;
      }
      
      private function removeDeco(e:ListEvent) : void
      {
         try
         {
            this.decoStyleView.decoInputs.removeItemsAt(this.decoStyleView.decoInputs.selectedIndex,1);
         }
         catch(e:Error)
         {
            decoStyleView.decoInputs.removeItemsAt(0,1);
         }
      }
      
      private function get decoStyleView() : DecoStyleView
      {
         return DecoStyleView(view);
      }
      
      private function get uiAsset() : Object
      {
         return this.decoStyleView.uiAsset;
      }
      
      private function addDeco(e:ListEvent) : void
      {
         ui.main.importToProject(FileManager.DECO);
      }
      
      private function removeColor(e:ListEvent) : void
      {
         try
         {
            this.decoStyleView.colorInputs.removeItemsAt(this.decoStyleView.colorInputs.selectedIndex,1);
         }
         catch(e:Error)
         {
            decoStyleView.colorInputs.removeItemsAt(0,1);
         }
      }
   }
}

