package com.livebrush.ui
{
   import com.livebrush.data.Settings;
   import com.livebrush.events.ListEvent;
   import com.livebrush.utils.ColorObj;
   import flash.events.Event;
   import flash.events.MouseEvent;
   
   public class GlobalColorController extends UIController
   {
      public function GlobalColorController(globalColorView:GlobalColorView)
      {
         super(globalColorView);
         this.init();
      }
      
      override protected function init() : void
      {
         this.uiAsset.addEventListener(Event.CHANGE,this.propsChangeEvent);
         this.uiAsset.addEventListener(MouseEvent.MOUSE_DOWN,this.mouseEvent);
         this.uiAsset.addEventListener(MouseEvent.MOUSE_UP,this.mouseEvent);
         this.uiAsset.addEventListener(MouseEvent.CLICK,this.mouseEvent);
         this.globalColorView.colorInputs.typeInput.addEventListener(Event.CHANGE,this.propsChangeEvent);
         this.globalColorView.colorInputs.addEventListener(ListEvent.ADD,this.addColor);
         this.globalColorView.colorInputs.addEventListener(ListEvent.REMOVE,this.removeColor);
         this.globalColorView.colorInputs.addEventListener(Event.CHANGE,this.propsChangeEvent);
      }
      
      private function addColor(e:ListEvent) : void
      {
         try
         {
            this.globalColorView.colorInputs.addItemAt(this.globalColorView.colorInputs.list[this.globalColorView.colorInputs.selectedIndex].copy(),this.globalColorView.colorInputs.selectedIndex);
         }
         catch(e:Error)
         {
            globalColorView.colorInputs.addItemAt(globalColorView.colorInputs.list[0].copy(),0);
         }
         catch(e:Error)
         {
            globalColorView.colorInputs.addItemAt(new ColorObj(16711680,true),0);
         }
      }
      
      private function mouseEvent(e:MouseEvent) : void
      {
         var settings:Settings = null;
         var styleSettings:Settings = null;
         if(e.type == MouseEvent.MOUSE_DOWN)
         {
            if(e.target.name == "bg")
            {
               this.uiAsset.startDrag();
            }
         }
         else if(e.type == MouseEvent.MOUSE_UP)
         {
            this.uiAsset.stopDrag();
         }
         else if(e.type == MouseEvent.CLICK)
         {
            if(e.target.name == "pullStyleBtn")
            {
               settings = ui.styleManager.activeStyle.strokeStyle.settings;
               settings.alpha = this.globalColorView.settings.alpha;
               this.globalColorView.settings = settings;
               this.globalColorView.applyProps();
               ui.pushColorProps(settings);
            }
            else if(e.target.name == "pushColorBtn")
            {
               styleSettings = ui.styleManager.activeStyle.strokeStyle.settings;
               settings = this.globalColorView.settings;
               styleSettings.colorType = settings.colorType;
               styleSettings.colorObjList = settings.colorObjList;
               styleSettings.colorSteps = settings.colorSteps;
               styleSettings.colorHold = settings.colorHold;
               ui.styleManager.activeStyle.strokeStyle.settings = styleSettings;
               ui.styleManager.pushStyle();
               ui.pushColorProps(settings);
            }
            else if(e.target.name == "helpBtn")
            {
               _loadHelp();
            }
            else if(e.target.name == "toggleBtn")
            {
               ui.toggleGlobalColor();
            }
         }
      }
      
      private function get globalColorView() : GlobalColorView
      {
         return GlobalColorView(view);
      }
      
      private function propsChangeEvent(e:Event) : void
      {
         e.stopImmediatePropagation();
         this.globalColorView.settings = this.globalColorView.settings;
         ui.pushColorProps(this.globalColorView.settings);
      }
      
      private function get uiAsset() : Object
      {
         return this.globalColorView.uiAsset;
      }
      
      private function removeColor(e:ListEvent) : void
      {
         try
         {
            this.globalColorView.colorInputs.removeItemsAt(this.globalColorView.colorInputs.selectedIndex,1);
         }
         catch(e:Error)
         {
            globalColorView.colorInputs.removeItemsAt(0,1);
         }
      }
   }
}

