package com.livebrush.ui
{
   import com.livebrush.data.FileManager;
   import com.livebrush.data.GlobalSettings;
   import flash.events.Event;
   import flash.events.MouseEvent;
   
   public class GlobalSettingsController extends UIController
   {
      public function GlobalSettingsController(globalSettingsView:GlobalSettingsView)
      {
         super(globalSettingsView);
         this.init();
      }
      
      override protected function init() : void
      {
         this.uiAsset.addEventListener(Event.CHANGE,this.propsChangeEvent);
         this.uiAsset.addEventListener(MouseEvent.CLICK,this.mouseEvent);
         this.panelAsset.addEventListener(MouseEvent.MOUSE_DOWN,this.panelMouseEvent);
         this.panelAsset.addEventListener(MouseEvent.MOUSE_UP,this.panelMouseEvent);
      }
      
      private function get panelAsset() : Object
      {
         return this.globalSettingsView.panelAsset;
      }
      
      private function mouseEvent(e:MouseEvent) : void
      {
         switch(e.target.name)
         {
            case "presetsBtn":
               FileManager.getInstance().copyAppFiles();
               break;
            case "closeBtn":
               ui.globalSettingsView = null;
               ui.closeWindow(this.globalSettingsView);
         }
      }
      
      override public function die() : void
      {
         this.panelAsset.stopDrag();
         this.uiAsset.removeEventListener(MouseEvent.CLICK,this.mouseEvent);
         this.uiAsset.removeEventListener(Event.CHANGE,this.propsChangeEvent);
         this.panelAsset.removeEventListener(MouseEvent.MOUSE_DOWN,this.panelMouseEvent);
         this.panelAsset.removeEventListener(MouseEvent.MOUSE_UP,this.panelMouseEvent);
      }
      
      private function panelMouseEvent(e:MouseEvent) : void
      {
         if(e.type == MouseEvent.CLICK && e.target.name.indexOf("help") > -1)
         {
            _loadHelp();
         }
         else if(e.type == MouseEvent.MOUSE_DOWN && e.target.name == "titleBtn" && this.globalSettingsView.enableDrag)
         {
            this.panelAsset.startDrag();
         }
         else if(e.type == MouseEvent.MOUSE_UP && e.target.name == "titleBtn" && this.globalSettingsView.enableDrag)
         {
            this.panelAsset.stopDrag();
         }
      }
      
      private function propsChangeEvent(e:Event) : void
      {
         GlobalSettings.CACHE_REALTIME = this.globalSettingsView.uiAsset.cacheVectors.selected;
         GlobalSettings.CACHE_DECOS = this.globalSettingsView.uiAsset.cacheDecos.selected;
         GlobalSettings.CHECK_FOR_UPDATES = this.globalSettingsView.uiAsset.checkForUpdates.selected;
         GlobalSettings.SHOW_BUSY_WARNINGS = this.globalSettingsView.uiAsset.showBusyWarnings.selected;
         GlobalSettings.CACHE_DELAY = Math.min(4000,Math.max(50,Number(this.globalSettingsView.uiAsset.cacheDelay.text) * 1000));
      }
      
      private function get globalSettingsView() : GlobalSettingsView
      {
         return GlobalSettingsView(view);
      }
      
      private function get uiAsset() : SettingsUI
      {
         return this.globalSettingsView.uiAsset;
      }
   }
}

