package com.livebrush.ui
{
   import flash.events.Event;
   import flash.events.MouseEvent;
   
   public class NewProjectController extends UIController
   {
      public function NewProjectController(newProjectView:NewProjectView)
      {
         super(newProjectView);
         this.init();
      }
      
      override protected function init() : void
      {
         this.uiAsset.addEventListener(Event.CHANGE,this.propsChangeEvent);
         this.uiAsset.addEventListener(MouseEvent.CLICK,this.mouseEvent);
         this.panelAsset.addEventListener(MouseEvent.MOUSE_DOWN,this.panelMouseEvent);
         this.panelAsset.addEventListener(MouseEvent.MOUSE_UP,this.panelMouseEvent);
      }
      
      private function mouseEvent(e:MouseEvent) : void
      {
         switch(e.target.name)
         {
            case "cancelBtn":
               ui.newProjectView = null;
               ui.closeWindow(this.newProjectView);
               break;
            case "okBtn":
               ui.createNewProject(this.uiAsset.sizeList.selectedIndex);
               ui.newProjectView = null;
               ui.closeWindow(this.newProjectView);
         }
      }
      
      override public function die() : void
      {
         this.panelAsset.stopDrag();
         this.uiAsset.removeEventListener(MouseEvent.CLICK,this.mouseEvent);
         this.uiAsset.removeEventListener(Event.CHANGE,this.propsChangeEvent);
         this.panelAsset.removeEventListener(MouseEvent.MOUSE_DOWN,this.panelMouseEvent);
         this.panelAsset.removeEventListener(MouseEvent.MOUSE_UP,this.panelMouseEvent);
      }
      
      private function panelMouseEvent(e:MouseEvent) : void
      {
         if(e.type == MouseEvent.CLICK && e.target.name.indexOf("help") > -1)
         {
            _loadHelp();
         }
         else if(e.type == MouseEvent.MOUSE_DOWN && e.target.name == "titleBtn" && this.newProjectView.enableDrag)
         {
            this.panelAsset.startDrag();
         }
         else if(e.type == MouseEvent.MOUSE_UP && e.target.name == "titleBtn" && this.newProjectView.enableDrag)
         {
            this.panelAsset.stopDrag();
         }
      }
      
      private function propsChangeEvent(e:Event) : void
      {
      }
      
      private function get uiAsset() : NewProjectUI
      {
         return this.newProjectView.uiAsset;
      }
      
      private function get panelAsset() : Object
      {
         return this.newProjectView.panelAsset;
      }
      
      private function get newProjectView() : NewProjectView
      {
         return NewProjectView(view);
      }
   }
}

