package com.livebrush.ui
{
   import com.livebrush.events.ListEvent;
   import flash.display.Sprite;
   import flash.events.Event;
   import flash.events.MouseEvent;
   
   public class RichListEditor extends RichList
   {
      public var orderEditable:Boolean = true;
      
      public var minListLength:int = 1;
      
      public var richListEditorUI:RichListEditorUI;
      
      public function RichListEditor(richListEditorUI:RichListEditorUI, richItemObject:Class = null)
      {
         super(richListEditorUI._list,richItemObject);
         this.richListEditorUI = richListEditorUI;
         this.init();
      }
      
      private function init() : void
      {
         this.richListEditorUI.addEventListener(Event.CHANGE,changeEvent);
         this.richListEditorUI.addEventListener(MouseEvent.CLICK,this.btnClickEvent);
      }
      
      private function btnClickEvent(e:MouseEvent) : void
      {
         var name:String = e.target.name;
         if(name.indexOf("Btn") > -1)
         {
            if(name == "removeBtn" && length > this.minListLength)
            {
               dispatchEvent(new ListEvent(ListEvent.REMOVE,false,false,selectedIndex));
            }
            else if(name == "addBtn")
            {
               dispatchEvent(new ListEvent(ListEvent.ADD,false,false,selectedIndex));
            }
            else if(name == "upBtn" && selectedIndex != 0)
            {
               if(this.orderEditable)
               {
                  moveItem(selectedIndex,-1);
               }
               dispatchEvent(new Event(Event.CHANGE));
            }
            else if(name == "downBtn" && selectedIndex != length - 1)
            {
               if(this.orderEditable)
               {
                  moveItem(selectedIndex,1);
               }
               dispatchEvent(new Event(Event.CHANGE));
            }
         }
      }
      
      override public function set enabled(b:Boolean) : *
      {
         super.enabled = this.uiAsset.mouseChildren = b;
      }
      
      override public function get uiAsset() : Sprite
      {
         return this.richListEditorUI;
      }
   }
}

