package com.livebrush.ui
{
   import com.livebrush.events.ListEvent;
   import com.livebrush.utils.ColorUtils;
   import flash.display.DisplayObjectContainer;
   import flash.display.Sprite;
   import flash.events.EventDispatcher;
   import flash.events.MouseEvent;
   
   public class RichListItem extends EventDispatcher
   {
      public static var ITEM_UI:Class = RichListItemUI;
      
      public var listItemUIObject:Class;
      
      protected var _data:Object;
      
      private var _parent:DisplayObjectContainer;
      
      private var _lastMouseEvent:MouseEvent;
      
      private var _moveTimeout:int;
      
      public var index:int;
      
      public var listItemUI:Sprite;
      
      public var parentList:RichList;
      
      private var _moving:Boolean = false;
      
      protected var _selected:Boolean = false;
      
      public function RichListItem(parent:DisplayObjectContainer, y:Number = 0, listItemUIObject:Class = null)
      {
         super();
         this._parent = parent;
         if(listItemUIObject == null)
         {
            this.listItemUIObject = ITEM_UI;
         }
         else
         {
            this.listItemUIObject = listItemUIObject;
         }
         this.init();
         this.y = y;
      }
      
      protected function _mouseClick(e:MouseEvent) : void
      {
         if(e.target == this.highlight || e.target == this.uiAsset["_label"])
         {
            dispatchEvent(new ListEvent(ListEvent.SELECT));
         }
      }
      
      public function get lastMouseEvent() : MouseEvent
      {
         return this._lastMouseEvent;
      }
      
      protected function _setData(o:Object) : void
      {
         this.label = o.label;
      }
      
      protected function _mouseOut() : void
      {
         if(!this.selected)
         {
            this.highlight.alpha = 0;
         }
      }
      
      public function set data(o:Object) : void
      {
         this._data = o;
         this._setData(o);
      }
      
      protected function _setVisible(b:Boolean) : void
      {
         try
         {
            if(b)
            {
               this._parent.addChild(this.listItemUI);
            }
            else
            {
               this._parent.removeChild(this.listItemUI);
            }
         }
         catch(e:Error)
         {
         }
      }
      
      protected function _setSelected(b:Boolean) : void
      {
         if(b)
         {
            this.highlight.alpha = 1;
            ColorUtils.tintObject(this.highlight,26316,0.25);
            this._selected = b;
         }
         else
         {
            this._selected = b;
            ColorUtils.resetColor(this.highlight);
            this._mouseOut();
         }
      }
      
      private function init() : void
      {
         this.listItemUI = new this.listItemUIObject();
         this._lastMouseEvent = new MouseEvent(MouseEvent.MOUSE_MOVE);
         this.listItemUI.addEventListener(MouseEvent.MOUSE_OVER,this.mouseEvent);
         this.listItemUI.addEventListener(MouseEvent.MOUSE_OUT,this.mouseEvent);
         this.listItemUI.addEventListener(MouseEvent.MOUSE_DOWN,this.mouseEvent);
         this.listItemUI.addEventListener(MouseEvent.MOUSE_UP,this.mouseEvent);
         this.listItemUI.addEventListener(MouseEvent.CLICK,this.mouseEvent);
      }
      
      protected function _mouseOver() : void
      {
         if(!this.selected)
         {
            this.highlight.alpha = 0.5;
         }
         try
         {
            this.parentList.hoverItem = this;
         }
         catch(e:Error)
         {
         }
      }
      
      public function get data() : Object
      {
         return this._data;
      }
      
      public function set visible(b:Boolean) : void
      {
         this._setVisible(b);
      }
      
      public function set label(s:String) : void
      {
         this.uiAsset["_label"].text = s;
      }
      
      public function set y(y:Number) : void
      {
         this.listItemUI.y = y;
      }
      
      protected function get highlight() : Sprite
      {
         return this.uiAsset["_highlight"];
      }
      
      private function mouseEvent(e:MouseEvent) : void
      {
         this._lastMouseEvent = e;
         if(e.type == MouseEvent.MOUSE_OVER)
         {
            this._mouseOver();
         }
         else if(e.type == MouseEvent.MOUSE_OUT)
         {
            this._mouseOut();
         }
         else if(e.type == MouseEvent.MOUSE_DOWN)
         {
            this._mouseClick(e);
         }
         else if(e.type != MouseEvent.MOUSE_UP)
         {
            if(e.type == MouseEvent.CLICK)
            {
            }
         }
      }
      
      public function set selected(b:Boolean) : void
      {
         this._setSelected(b);
      }
      
      public function get visible() : Boolean
      {
         return this._parent.contains(this.uiAsset);
      }
      
      public function get uiAsset() : Sprite
      {
         return this.listItemUI;
      }
      
      public function get selected() : Boolean
      {
         return this._selected;
      }
      
      public function lockUI(b:Boolean = true) : void
      {
      }
   }
}

