package com.livebrush.ui
{
   import flash.events.Event;
   import flash.events.MouseEvent;
   
   public class SaveImageController extends UIController
   {
      public function SaveImageController(saveImageView:SaveImageView)
      {
         super(saveImageView);
         this.init();
      }
      
      override protected function init() : void
      {
         this.uiAsset.addEventListener(Event.CHANGE,this.propsChangeEvent);
         this.uiAsset.addEventListener(MouseEvent.CLICK,this.mouseEvent);
         this.panelAsset.addEventListener(MouseEvent.MOUSE_DOWN,this.panelMouseEvent);
         this.panelAsset.addEventListener(MouseEvent.MOUSE_UP,this.panelMouseEvent);
      }
      
      private function propsChangeEvent(e:Event) : void
      {
      }
      
      private function get saveImageView() : SaveImageView
      {
         return SaveImageView(view);
      }
      
      private function mouseEvent(e:MouseEvent) : void
      {
         switch(e.target.name)
         {
            case "cancelBtn":
               ui.saveImageView = null;
               ui.closeWindow(this.saveImageView);
               break;
            case "okBtn":
               ui.main.saveAsImage(this.uiAsset.sizeList.selectedIndex,this.saveImageView.data.allLayers);
               ui.saveImageView = null;
               ui.closeWindow(this.saveImageView);
         }
      }
      
      override public function die() : void
      {
         this.panelAsset.stopDrag();
         this.uiAsset.removeEventListener(MouseEvent.CLICK,this.mouseEvent);
         this.uiAsset.removeEventListener(Event.CHANGE,this.propsChangeEvent);
         this.panelAsset.removeEventListener(MouseEvent.MOUSE_DOWN,this.panelMouseEvent);
         this.panelAsset.removeEventListener(MouseEvent.MOUSE_UP,this.panelMouseEvent);
      }
      
      private function panelMouseEvent(e:MouseEvent) : void
      {
         if(e.type == MouseEvent.CLICK && e.target.name.indexOf("help") > -1)
         {
            _loadHelp();
         }
         else if(e.type == MouseEvent.MOUSE_DOWN && e.target.name == "titleBtn" && this.saveImageView.enableDrag)
         {
            this.panelAsset.startDrag();
         }
         else if(e.type == MouseEvent.MOUSE_UP && e.target.name == "titleBtn" && this.saveImageView.enableDrag)
         {
            this.panelAsset.stopDrag();
         }
      }
      
      private function get panelAsset() : Object
      {
         return this.saveImageView.panelAsset;
      }
      
      private function get uiAsset() : SaveImageUI
      {
         return this.saveImageView.uiAsset;
      }
   }
}

