package com.livebrush.ui
{
   import com.livebrush.data.Settings;
   import fl.controls.ComboBox;
   import fl.data.DataProvider;
   import flash.display.Sprite;
   import flash.events.Event;
   
   public class SequenceList extends RichListEditor
   {
      public var speedInput:PropInputHorizontal;
      
      public var holdInput:PropInputHorizontal;
      
      public var typeInput:ComboBox;
      
      public var sequenceListUI:SequenceListUI;
      
      public function SequenceList(sequenceListUI:SequenceListUI, richItemObject:Class = null)
      {
         super(sequenceListUI._listEditor,richItemObject);
         this.sequenceListUI = sequenceListUI;
         this.init();
      }
      
      public function get type() : Object
      {
         return this.typeInput.selectedItem.data;
      }
      
      override public function set enabled(b:Boolean) : *
      {
         super.enabled = this.typeInput.enabled = this.speedInput.enabled = this.holdInput.enabled = b;
      }
      
      public function get speed() : Number
      {
         return this.speedInput.value;
      }
      
      public function set speedLabel(s:String) : *
      {
         this.speedInput.label = s;
      }
      
      public function set speed(n:Number) : *
      {
         this.speedInput.value = n;
      }
      
      public function get speedEnabled() : Boolean
      {
         return this.speedInput.enabled;
      }
      
      public function set type(o:Object) : void
      {
         this.typeInput.selectedIndex = Settings.idToIndex(String(o),this.typeInput.dataProvider.toArray(),"data");
      }
      
      public function set typeList(l:Array) : void
      {
         this.typeInput.dataProvider = new DataProvider(l);
      }
      
      public function set speedEnabled(b:Boolean) : *
      {
         this.speedInput.enabled = b;
      }
      
      override public function get uiAsset() : Sprite
      {
         return this.sequenceListUI;
      }
      
      private function init() : void
      {
         this.typeInput = this.uiAsset["_type"];
         this.speedInput = this.uiAsset["_speed"];
         this.holdInput = this.uiAsset["_hold"];
         this.typeInput.addEventListener(Event.CHANGE,changeEvent);
      }
   }
}

