package com.livebrush.ui
{
   import com.livebrush.events.ListEvent;
   import fl.controls.CheckBox;
   import flash.display.Bitmap;
   import flash.display.DisplayObjectContainer;
   import flash.display.MovieClip;
   import flash.events.Event;
   import flash.events.FocusEvent;
   import flash.events.KeyboardEvent;
   import flash.events.MouseEvent;
   import flash.text.TextField;
   import flash.text.TextFieldType;
   import flash.ui.Keyboard;
   
   public class StyleListItem extends RichListItem
   {
      private var bg:MovieClip;
      
      private var labelUI:TextField;
      
      private var thumbBmp:Bitmap;
      
      public var enabledUI:CheckBox;
      
      private var thumb:MovieClip;
      
      private var editing:Boolean = false;
      
      private var _colorHexValue:String = "FFFFFF";
      
      private var _active:Boolean = true;
      
      private var _colorValue:uint = 16777215;
      
      public function StyleListItem(parent:DisplayObjectContainer, y:Number = 0)
      {
         super(parent,y,StyleListItemUI);
         this.init();
      }
      
      override protected function _mouseClick(e:MouseEvent) : void
      {
         dispatchEvent(new ListEvent(ListEvent.SELECT));
      }
      
      public function get label() : String
      {
         return this.labelUI.text;
      }
      
      private function rightClick(e:MouseEvent) : void
      {
         e.stopImmediatePropagation();
         parentList.rightClickItemIndex = index;
         dispatchEvent(new MouseEvent(e.type));
      }
      
      private function init() : void
      {
         this.labelUI = uiAsset["_label"];
         highlight.doubleClickEnabled = true;
         this._toggleLabelEdit();
         this._toggleLabelEdit();
         this.labelUI.addEventListener(KeyboardEvent.KEY_DOWN,this.keyEvent);
         this.labelUI.addEventListener(Event.CHANGE,this.changeEvent);
         this.labelUI.addEventListener(MouseEvent.RIGHT_CLICK,this.rightClick);
      }
      
      private function changeEvent(e:Event) : void
      {
         if(e.target == this.labelUI)
         {
            e.stopImmediatePropagation();
         }
      }
      
      private function doubleClickEvent(e:MouseEvent) : void
      {
      }
      
      private function applyLabel(e:Event = null) : void
      {
         try
         {
            e.stopImmediatePropagation();
         }
         catch(e:Error)
         {
         }
         data.name = this.label;
         this._toggleLabelEdit();
         dispatchEvent(new Event(Event.CHANGE));
      }
      
      override public function set label(s:String) : void
      {
         this.labelUI.text = s;
      }
      
      private function _toggleLabelEdit() : void
      {
         this.editing = !this.editing;
         this.labelUI.doubleClickEnabled = !this.editing;
         this.labelUI.selectable = this.editing;
         this.labelUI.border = this.labelUI.background = this.editing;
         if(!this.editing)
         {
            this.labelUI.addEventListener(MouseEvent.DOUBLE_CLICK,this.doubleClickEvent);
            this.labelUI.removeEventListener(FocusEvent.FOCUS_OUT,this.applyLabel);
            this.labelUI.removeEventListener(FocusEvent.MOUSE_FOCUS_CHANGE,this.applyLabel);
            this.labelUI.type = TextFieldType.DYNAMIC;
         }
         else
         {
            this.labelUI.removeEventListener(MouseEvent.DOUBLE_CLICK,this.doubleClickEvent);
            this.labelUI.addEventListener(FocusEvent.FOCUS_OUT,this.applyLabel);
            this.labelUI.addEventListener(FocusEvent.MOUSE_FOCUS_CHANGE,this.applyLabel);
            this.labelUI.type = TextFieldType.INPUT;
            this.labelUI.setSelection(0,this.labelUI.length);
         }
      }
      
      private function keyEvent(e:KeyboardEvent) : void
      {
         if(e.keyCode == Keyboard.ENTER && e.type == KeyboardEvent.KEY_DOWN && e.target == this.labelUI)
         {
            this.applyLabel();
         }
         else if(e.type == KeyboardEvent.KEY_DOWN && e.target == this.labelUI)
         {
            e.stopImmediatePropagation();
         }
      }
      
      override protected function _setData(o:Object) : void
      {
         this.label = o.name;
      }
   }
}

