package com.livebrush.ui
{
   import com.livebrush.data.GlobalSettings;
   import flash.desktop.Clipboard;
   import flash.desktop.ClipboardFormats;
   import flash.events.Event;
   import flash.events.MouseEvent;
   
   public class TitlebarController extends UIController
   {
      public function TitlebarController(titlebarView:TitlebarView)
      {
         super(titlebarView);
         this.init();
      }
      
      private function get titlebarView() : TitlebarView
      {
         return TitlebarView(view);
      }
      
      private function get brushPropsModel() : BrushPropsModel
      {
         return this.titlebarView.brushPropsModel;
      }
      
      private function changeListener(e:Event) : void
      {
         GlobalSettings.STROKE_BUFFER = this.uiAsset.strokeBuffer.value;
      }
      
      private function mouseEvent(e:MouseEvent) : void
      {
         switch(e.target.name)
         {
            case "saveBtn":
               ui.main.saveProject();
               break;
            case "styleBtn":
               ui.toggleToolProps();
               break;
            case "prefsBtn":
               ui.showGlobalPrefs();
               break;
            case "quickSaveBtn":
               Clipboard.generalClipboard.clear();
               Clipboard.generalClipboard.setData(ClipboardFormats.BITMAP_FORMAT,canvasManager.getImage(canvasManager.activeLayerDepths),false);
               break;
            case "helpBtn":
               _loadHelp();
         }
         switch(e.target.parent.name)
         {
            case "drawVectorsBtn":
               ui.toggleDrawMode(0);
               break;
            case "drawPixelsBtn":
               ui.toggleDrawMode(1);
         }
      }
      
      override protected function init() : void
      {
         this.uiAsset.addEventListener(Event.CHANGE,this.changeListener);
         this.uiAsset.addEventListener(MouseEvent.CLICK,this.mouseEvent);
      }
      
      private function get uiAsset() : Object
      {
         return this.titlebarView.uiAsset;
      }
   }
}

