package com.livebrush.ui
{
   import flash.display.Sprite;
   import flash.events.MouseEvent;
   
   public class ToolbarController extends UIController
   {
      public function ToolbarController(toolbarView:ToolbarView)
      {
         super(toolbarView);
         this.init();
      }
      
      private function get toolbarView() : ToolbarView
      {
         return ToolbarView(view);
      }
      
      override protected function init() : void
      {
         for(var i:int = 0; i < this.toolBtns.length; i++)
         {
            this.toolBtns[i].doubleClickEnabled = true;
            this.toolBtns[i].getChildAt(0).doubleClickEnabled = true;
            this.toolBtns[i].mouseEnabled = true;
            this.toolBtns[i].addEventListener(MouseEvent.DOUBLE_CLICK,this.mouseEvent);
            this.toolBtns[i].addEventListener(MouseEvent.MOUSE_DOWN,this.mouseEvent);
         }
         this.toolbarAsset.addEventListener(MouseEvent.CLICK,this.mouseEvent);
      }
      
      private function mouseEvent(e:MouseEvent) : void
      {
         if(e.type == MouseEvent.DOUBLE_CLICK)
         {
            if(e.target.parent.name.indexOf("Btn") > -1 || e.target.name.indexOf("Btn") > -1)
            {
               ui.toggleToolProps();
            }
         }
         else if(e.type == MouseEvent.CLICK)
         {
            if(e.target.name == "lockColorBtn")
            {
               e.target.parent.gotoAndStop(2);
               ui.styleManager.lockColors(true);
            }
            else if(e.target.name == "unlockColorBtn")
            {
               e.target.parent.gotoAndStop(1);
               ui.styleManager.lockColors(false);
            }
            else if(e.target.name == "toggleBtn")
            {
               ui.togglePropsPanel();
            }
            else if(e.target.name == "_colorBg")
            {
               ui.toggleGlobalColor();
            }
            else if(e.target.name == "helpBtn")
            {
               _loadHelp();
            }
         }
         else if(e.type == MouseEvent.MOUSE_DOWN)
         {
            if(e.target.parent.name.indexOf("Btn") > -1)
            {
               ui.toolSelect(e.target.parent.toolName);
            }
         }
      }
      
      private function get toolbarAsset() : Sprite
      {
         return this.toolbarView.toolbarAsset;
      }
      
      private function get toolBtns() : Array
      {
         return this.toolbarView.toolBtns;
      }
   }
}

