package com.livebrush.ui
{
   import com.livebrush.data.StateManager;
   import fl.controls.CheckBox;
   import fl.controls.ColorPicker;
   import fl.controls.RadioButton;
   import fl.controls.TextInput;
   import fl.events.ComponentEvent;
   import flash.events.Event;
   import flash.events.MouseEvent;
   
   public class TransformPropsController extends UIController
   {
      public function TransformPropsController(transformPropsView:TransformPropsView)
      {
         super(transformPropsView);
         this.init();
      }
      
      override protected function init() : void
      {
         this.uiAsset.addEventListener(MouseEvent.CLICK,this.mouseEvent);
         this.uiAsset.scale.addEventListener(MouseEvent.CLICK,this.mouseEvent);
         this.uiAsset.rotate.addEventListener(MouseEvent.CLICK,this.mouseEvent);
         this.uiAsset.constrain.addEventListener(MouseEvent.CLICK,this.mouseEvent);
         this.uiAsset.addEventListener(ComponentEvent.ENTER,this.applyEvent);
         this.uiAsset.addEventListener(Event.CHANGE,this.changeEvent);
      }
      
      private function mouseEvent(e:MouseEvent) : void
      {
         if(e.target.name.indexOf("help") > -1)
         {
            switch(e.target.parent.name)
            {
               case "transformControlHead":
                  ui.loadHelp("transformControl");
                  break;
               case "scaleHead":
                  ui.loadHelp("transformInput");
                  break;
               case "colorHead":
                  ui.loadHelp("transformColor");
            }
         }
         else if(e.target is RadioButton || e.target is CheckBox)
         {
            StateManager.lock();
            this.transformPropsView.colorChanged = this.transformPropsView.alphaChanged = false;
            ui.pullToolProps(this.transformPropsView);
            StateManager.unlock(this);
         }
      }
      
      private function get transformPropsView() : TransformPropsView
      {
         return TransformPropsView(view);
      }
      
      private function changeEvent(e:Event) : void
      {
         if(e.target is ColorPicker)
         {
            this.transformPropsView.colorChanged = true;
            ui.pullToolProps(this.transformPropsView);
         }
         else if(e.target.parent == this.uiAsset.alphaInput)
         {
            this.transformPropsView.alphaChanged = true;
         }
         else
         {
            this.transformPropsView.colorChanged = this.transformPropsView.alphaChanged = false;
         }
      }
      
      private function applyEvent(e:ComponentEvent) : void
      {
         if(e.target is TextInput)
         {
            ui.pullToolProps(this.transformPropsView);
            this.transformPropsView.colorChanged = this.transformPropsView.alphaChanged = false;
         }
      }
      
      private function get uiAsset() : Object
      {
         return this.transformPropsView.uiAsset;
      }
   }
}

