package com.livebrush.utils
{
   import org.casalib.util.ColorUtil;
   
   public dynamic class ColorObj
   {
      public var enabled:Boolean = true;
      
      private var _color:uint = 16777215;
      
      private var _colorString:String = "FFFFFF";
      
      public function ColorObj(o:Object, enabled:Boolean = true)
      {
         super();
         if(o is String)
         {
            this.colorString = String(o);
         }
         else if(o is uint)
         {
            this.color = uint(o);
         }
         this.enabled = enabled;
      }
      
      private function _setColor(s:String) : void
      {
         this._color = uint("0x" + s);
      }
      
      public function get color() : uint
      {
         return this._color;
      }
      
      public function set color(u:uint) : void
      {
         this._color = u;
         this._setString(u);
      }
      
      public function set value(u:uint) : void
      {
         this.color = u;
      }
      
      public function set colorString(s:String) : void
      {
         this._colorString = s;
         this._setColor(s);
      }
      
      public function get value() : uint
      {
         return this.color;
      }
      
      public function get colorString() : String
      {
         return this._colorString;
      }
      
      private function _setString(u:uint) : void
      {
         var rgb:Object = ColorUtil.getRGB(u);
         this._colorString = ColorUtil.getHexStringFromRGB(rgb.r,rgb.g,rgb.b);
      }
      
      public function copy() : ColorObj
      {
         return new ColorObj(this._color,this.enabled);
      }
   }
}

