package com.livebrush.utils
{
   import com.livebrush.events.UpdateEvent;
   
   public class Update
   {
      public var type:String;
      
      public var delay:Boolean;
      
      public var data:Object;
      
      public function Update(type:String, data:Object = null, delay:Boolean = true)
      {
         super();
         this.type = type;
         this.data = data;
         this.delay = delay;
      }
      
      public static function brushStyleUpdate(data:Object = null, delay:Boolean = false) : Update
      {
         return new Update(UpdateEvent.BRUSH_STYLE,data,delay);
      }
      
      public static function projectUpdate(data:Object = null, delay:Boolean = false) : Update
      {
         return new Update(UpdateEvent.PROJECT,data,delay);
      }
      
      public static function finishUpdate(data:Object = null, delay:Boolean = false) : Update
      {
         return new Update(UpdateEvent.FINISH,data,delay);
      }
      
      public static function loadingUpdate(data:Object = null, delay:Boolean = false) : Update
      {
         return new Update(UpdateEvent.LOADING,data,delay);
      }
      
      public static function groupUpdate(data:Object = null, delay:Boolean = true) : Update
      {
         return new Update(UpdateEvent.GROUP,data,delay);
      }
      
      public static function colorUpdate(data:Object = null, delay:Boolean = false) : Update
      {
         return new Update(UpdateEvent.COLOR,data,delay);
      }
      
      public static function drawModeUpdate(data:Object = null, delay:Boolean = false) : Update
      {
         return new Update(UpdateEvent.DRAW_MODE,data,delay);
      }
      
      public static function beginUpdate(data:Object = null, delay:Boolean = false) : Update
      {
         return new Update(UpdateEvent.BEGIN,data,delay);
      }
      
      public static function dataUpdate(data:Object = null, delay:Boolean = false) : Update
      {
         return new Update(UpdateEvent.DATA,data,delay);
      }
      
      public static function transformUpdate(data:Object = null, delay:Boolean = false) : Update
      {
         return new Update(UpdateEvent.TRANSFORM,data,delay);
      }
      
      public static function windowUpdate(data:Object = null, delay:Boolean = false) : Update
      {
         return new Update(UpdateEvent.WINDOW,data,delay);
      }
      
      public static function layerUpdate(data:Object = null, delay:Boolean = false) : Update
      {
         return new Update(UpdateEvent.LAYER,data,delay);
      }
      
      public static function selectionUpdate(data:Object = null, delay:Boolean = true) : Update
      {
         return new Update(UpdateEvent.SELECTION,data,delay);
      }
      
      public static function uiUpdate(data:Object = null, delay:Boolean = false) : Update
      {
         return new Update(UpdateEvent.UI,data,delay);
      }
      
      public function generateEvent() : UpdateEvent
      {
         return new UpdateEvent(this.type,false,false,this.data,this.delay);
      }
   }
}

